;*******************************************************************************
;  Filename:    Bouton_Poussoir.asm                                            *
;                                                                              *
;  Version:  	13/09/2012    V1.0      Version originale                      *
;               13/02/2013    V1.1      Anti rebond BP                         *                                                               *
;                                                                              *
;  Author:      Philippe DOUILLARD                                             *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                                                              *
;  Acquisition des Entrees (Front montants, Anti rebond....                    *
;                                                                              *
;*******************************************************************************

;**************** Directive d' assemblage pour MPLAB   *************************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
    #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************
	
	extern Main

;*********************** VARIABLES EXTERNES ************************************
    extern  memo1,memo4,CPT_REBOND_1,CPT_REBOND_2,CPT_REBOND_3

;************************* SOUS ROUTINE ****************************************

PROG            CODE

Bouton_Poussoir
                global Bouton_Poussoir

;********** ANTI REBOND 1 ************************************ CONTACT REMOTE **

            btfss   PORTE,1         ; Si entree = 1 JUMP
            bra     AR_CPT_1        ; Saute entree = 0

            movlw   0xFA            ; Charge valeur MAXI
            cpfseq  CPT_REBOND_1    ; Saute si gal  max
            bra     INC_CPT_1       ; Saute  Incrementation
            bsf     memo4,0         ; SET flag anti rebonb
            bra     AR_suite_1      ; exit
INC_CPT_1   incf    CPT_REBOND_1,F  ; Incremente compteur
            bra     AR_suite_1      ; exit

AR_CPT_1    movlw   0x00            ; Charge valeur MINI
            cpfseq  CPT_REBOND_1    ; Saute si gal  mini
            bra     DEC_CPT_1       ; Saute  Incrementation
            bcf     memo4,0         ; RESET flag anti rebonb
            bra     AR_suite_1      ; exit
DEC_CPT_1   decf    CPT_REBOND_1,F  ; Incremente compteur
            bra     AR_suite_1      ; exit
AR_suite_1

;---------- Front montant 1 ------------------------------- CONTACT REMOTE -----
            bcf     memo4,2		; RESET bit front
            btfss   memo4,0 	; Si entree = 1 JUMP
            goto    FM_exit2    ; Sinon GOTO EXIT
            btfsc   memo4,1		; Si etat anterieur = 0 JUMP
            goto    FM_exit2    ; Sinon GOTO EXIT
            bsf     memo4,2		; SET bit front
FM_exit2
;---------- Front Descendant 1 ---------------------------- CONTACT REMOTE -----
            bcf     memo4,3		; RESET bit front
            btfsc   memo4,0 	; Si entree = 0 JUMP
            goto    FD_exit2    ; Sinon GOTO EXIT
            btfss   memo4,1		; Si etat anterieur = 1 JUMP
            goto    FD_exit2    ; Sinon GOTO EXIT
            bsf     memo4,3     ; SET bit front
FD_exit2
;---------- Memo etat anterieur --------------------------- CONTACT REMOTE -----
            btfss   memo4,0     ; Si entree = 1 JUMP
            bcf     memo4,1		; RESET bit (Memo etat anterieur)
            btfsc   memo4,0 	; Si Entree = 0 JUMP
            bsf     memo4,1		; SET bit (memo etat anterieur)

;********** ANTI REBOND 2 ******************************* SEUIL TEMPERATURE 1 **

            btfss   memo1,6         ; Si entree = 1 JUMP
            bra     AR_CPT_2        ; Saute entree = 0

            movlw   0xFA            ; Charge valeur MAXI
            cpfseq  CPT_REBOND_2    ; Saute si gal  max
            bra     INC_CPT_2       ; Saute  Incrementation
            bsf     memo4,4         ; SET flag anti rebonb
            bra     AR_suite_2      ; exit
INC_CPT_2   incf    CPT_REBOND_2,F  ; Incremente compteur
            bra     AR_suite_2      ; exit

AR_CPT_2    movlw   0x00            ; Charge valeur MINI
            cpfseq  CPT_REBOND_2    ; Saute si gal  mini
            bra     DEC_CPT_2       ; Saute  Incrementation
            bcf     memo4,4         ; RESET flag anti rebonb
            bra     AR_suite_2      ; exit
DEC_CPT_2   decf    CPT_REBOND_2,F  ; Incremente compteur
            bra     AR_suite_2      ; exit
AR_suite_2
;********** ANTI REBOND 3 ******************************* SEUIL TEMPERATURE 2 **

            btfss   memo1,7         ; Si entree = 1 JUMP
            bra     AR_CPT_3        ; Saute entree = 0

            movlw   0xFA            ; Charge valeur MAXI
            cpfseq  CPT_REBOND_3    ; Saute si gal  max
            bra     INC_CPT_3       ; Saute  Incrementation
            bsf     memo4,5         ; SET flag anti rebonb
            bra     AR_suite_3      ; exit
INC_CPT_3   incf    CPT_REBOND_3,F  ; Incremente compteur
            bra     AR_suite_3      ; exit

AR_CPT_3    movlw   0x00            ; Charge valeur MINI
            cpfseq  CPT_REBOND_3    ; Saute si gal  mini
            bra     DEC_CPT_3       ; Saute  Incrementation
            bcf     memo4,5         ; RESET flag anti rebonb
            bra     AR_suite_3      ; exit
DEC_CPT_3   decf    CPT_REBOND_3,F  ; Incremente compteur
            bra     AR_suite_3      ; exit
AR_suite_3

;--------------- exit ----------------------------------------------------------
exit		return                  ; retour du sous programme
			
            END
