;*******************************************************************************
;  Filename:    Commande_AREA.asm                                              *
;                                                                              *
;  Version:  	23/02/2013    V1.0      Version originale                      *
;                                                                              *
;                                                                              *
;  Author:        Philippe DOUILLARD                                           *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                                                              *
;  Commande VFD Affichage AREA SQUARE                                          *
;  Parametre 1 =    Position X1                 (0-255)                        *
;  Parametre 2 =    Position Y1                 (0-255)                        *
;  Parametre 3 =    Position X2                 (0-255)                        *
;  Parametre 4 =    Position Y2                 (0-255)                        *
;  Parametre 5 =    FONCTION                    (0 = Invert Area       0x49)   *
;                                               (1 = Fill Area         0x46)   *
;                                               (2 = Clear Area        0x43)   *
;                                               (3 = Set   Outline Boxe 0x4F)  *
;                                               (4 = Clear Outline Boxe 0x6F)  *
;                                                                              *
;*******************************************************************************

;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
        #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************
	
        extern  Main,par_rw0_rs0,par_rw0_rs1,dec8_bcd3,vol255_db_BCD
        extern  Commande_CLS,Delay_short

;********************** VARIABLES EXTERNES *************************************

        extern  param_1,param_2,param_3,param_4,param_5
        extern  temp1,temp2

;*********************** ADRESSE DES TABLES ************************************

;TABLE_CAR        EQU      0x0004000

;************************* SOUS ROUTINE ****************************************

PROG            CODE

Commande_AREA
                global Commande_AREA


                movff   param_1,temp1   ; Sauvegarde parametre

;--------------- Selection de la Fonction --------------------------------------
                movlw   d'00'           ; INVERT AREA ?
                cpfseq  param_5
                goto    suite1
                movlw   0x49            ; INVERT AREA
                movwf   temp2           ; Transfert parametre
                goto    suite_fin

suite1          movlw   d'01'           ; FILL AREA ?
                cpfseq  param_5
                goto    suite2
                movlw   0x46            ; FILL AREA
                movwf   temp2           ; Transfert parametre
                goto    suite_fin

suite2          movlw   d'02'           ; CLEAR AREA ?
                cpfseq  param_5
                goto    suite3
                movlw   0x43            ; CLEAR AREA
                movwf   temp2           ; Transfert parametre
                goto    suite_fin

suite3          movlw   d'03'           ; SET OUTLINE AREA ?
                cpfseq  param_5
                goto    suite4
                movlw   0x4F            ; SET OUTINE AREA
                movwf   temp2           ; Transfert parametre
                goto    suite_fin

suite4          movlw   d'04'           ; CLEAR OUTINE AREA ?
                cpfseq  param_5
                goto    suite_fin
                movlw   0x6F            ; CLEAR OUTLINE AREA
                movwf   temp2           ; Transfert parametre
                goto    suite_fin
suite_fin

;------------- Commande AREA ---------------------------------------------------

                movlw   0xF1            ; SET AREA
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movff   temp1,param_1   ; Transfert parametre X1
                call    par_rw0_rs1     ; routine comunication paralelle

                movff   param_2,param_1 ; Transfert parametre Y1
                call    par_rw0_rs1     ; routine comunication paralelle

                movff   param_3,param_1 ; Transfert parametre X2
                call    par_rw0_rs1     ; routine comunication paralelle

                movff   param_4,param_1 ; Transfert parametre Y2
                call    par_rw0_rs1     ; routine comunication paralelle

                movff   temp2,param_1   ; Transfert parametre CMD
                call    par_rw0_rs1     ; routine comunication paralelle

                call    Delay_short

;--------------- exit ----------------------------------------------------------

exit            return                  ; retour du sous programme

                END
