;*******************************************************************************
;  Filename:    Commande_DB.asm                                                *
;                                                                              *
;  Version:  	22/02/2013    V1.0      Version originale                      *
;                                                                              *
;  Author:      Philippe DOUILLARD                                             *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                                                              *
;  Affichage du volume dans la barre de navigarion                             *
;                                                                              *
;*******************************************************************************

;**************** Directive d' assemblage pour MPLAB   *************************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
    #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************
	
    extern  Main,Delay_short,par_rw0_rs0,par_rw0_rs1
    extern  vol255_db_BCD
    extern  Commande_TEXT,Commande_AREA

;********************** VARIABLES EXTERNES *************************************

    extern  param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8
    extern  param_9,temp1,temp2,temp3,temp4,temp5
    extern  MASTER_Val

;************************* SOUS ROUTINE ****************************************

PROG            CODE

Commande_DB
                global Commande_DB

;-------------- Effacement zone affichage --------------------------------------


                movff   param_6,param_1     ; X -> X1
                movlw   d'05'               ; W=5
                subwf   param_7,0             ; W = Param_7(Y) - 5
                movwf   param_2             ; W -> Y2
                movlw   d'23'               ; W=23
                addwf   param_6,0             ; W = X+23
                movwf   param_3             ; W -> Y2
                movff   param_7,param_4
                movlw   d'02'               ; CLEAR
                movwf   param_5
                call    Commande_AREA

;--------------- Selection de la fonte -----------------------------------------
                movlw   d'00'           ; FONTE 5x5     SPACING 1
                cpfseq  param_8
                goto    suite1

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x41            ; 'A' Font 5x5
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x31            ; '1' Espacing 1 pixels
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    suite_fin

suite1          movlw   d'01'           ; FONTE 5x5     SPACING 2
                cpfseq  param_8
                goto    suite2

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x41            ; 'A' Font 5x5
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x32            ; '2' Espacing 2 pixels
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    suite_fin

suite2          movlw   d'02'           ; FONTE 5x7     SPACING 1
                cpfseq  param_8
                goto    suite3

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x42            ; 'B' Font 5x7
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x31            ; '1' Espacing 1 pixels
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    suite_fin

suite3          movlw   d'03'           ; FONTE 5x7     SPACING 2
                cpfseq  param_8
                goto    suite4

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x42            ; 'B' Font 5x7
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x32            ; '2' Espacing 2 pixels
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    suite_fin

suite4          movlw   d'04'           ; FONTE 10x14     SPACING 1
                cpfseq  param_8
                goto    suite5

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x43            ; 'C' Font 10x14
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x31            ; '1' Espacing 1 pixels
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    suite_fin

suite5          movlw   d'05'           ; FONTE 10x14     SPACING 2
                cpfseq  param_8
                goto    suite_fin

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x43            ; 'C' Font 10x14
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x32            ; '2' Espacing 2 pixels
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
suite_fin

;---------------Affichage volume (-96.0/+31.5 dB)--------------------------------------------

                movlw   0xF0                ; SET GRAFIC POSITION
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs0         ; routine comunication paralelle

                movff   param_6,param_1       ; X
                call    par_rw0_rs1         ; routine comunication paralelle

                movff   param_7,param_1       ; X
                call    par_rw0_rs1         ; routine comunication paralelle

                movff   param_9,param_1
                call    vol255_db_BCD

                movff   param_1,temp5       ; Sauvegarde valeur dizaine

                movff   param_4,param_1     ; Transfert signe vers parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movf    temp5,0             ; valeur des dizaines
                addlw   0x30                ; adition avec caractere '0'
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movf    param_2,0           ; valeur des unites
                addlw   0x30                ; addition avec caractere '0'
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   0x2E                ; 'Point'
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movf    param_3,0           ; valeur des unitees
                addlw   0x30                ; addition avec caractere '0'
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

;--------------- exit ----------------------------------------------------------
exit            return                      ; retour du sous programme
			
                END
