;*******************************************************************************
;  Filename:    Commande_TEXT.asm                                              *
;                                                                              *
;  Version:  	22/02/2013    V1.0      Version originale                      *
;                                                                              *
;                                                                              *
;  Author:        Philippe DOUILLARD                                           *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                                                              *
;  Commande VFD Affichage chaine TEXT                                          *
;  Parametre 1 =    Position X                      (0-255)                    *
;  Parametre 2 =    Position Y                      (0-255)                    *                                               *
;  Parametre 3 =    N chaine                       (0-255)                    *                                                  *
;  Parametre 4 =    Nb Caracteres                   (0-255)                    *                                              *
;  Parametre 5 =    FONTE                           (0 = 5x5    espacing 1)    *
;                                                   (1 = 5x5    espacing 2)    *
;                                                   (2 = 5x7    espacing 2)    *
;                                                   (3 = 5x7    espacing 2)    *
;                                                   (4 = 10x14  espacing 1)    *
;                                                   (5 = 10x14  espacing 2)    *
;                                                                              *
;*******************************************************************************

;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
        #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************
	
	extern  Main,par_rw0_rs0,par_rw0_rs1,dec8_bcd3,vol255_db_BCD
    extern  Commande_CLS

;********************** VARIABLES EXTERNES *************************************

        extern param_1,param_2,param_3,param_4,param_5
        extern ADRES_LOW, ADRES_HIGH
        extern temp1

;*********************** ADRESSE DES TABLES ************************************

;TABLE_CAR        EQU      0x0004000

;************************* SOUS ROUTINE ****************************************

PROG            CODE

Commande_TEXT
                global Commande_TEXT


                movff   param_1,temp1   ; Sauvegarde parametre

;--------------- Selection de la fonte -----------------------------------------
                movlw   d'00'           ; FONTE 5x5     SPACING 1
                cpfseq  param_5
                goto    suite1

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x41            ; 'A' Font 5x5
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x31            ; '1' Espacing 1 pixels
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    suite_fin

suite1          movlw   d'01'           ; FONTE 5x5     SPACING 2
                cpfseq  param_5
                goto    suite2

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x41            ; 'A' Font 5x5
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x32            ; '2' Espacing 2 pixels
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    suite_fin

suite2          movlw   d'02'           ; FONTE 5x7     SPACING 1
                cpfseq  param_5
                goto    suite3

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x42            ; 'B' Font 5x7
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x31            ; '1' Espacing 1 pixels
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    suite_fin

suite3          movlw   d'03'           ; FONTE 5x7     SPACING 2
                cpfseq  param_5
                goto    suite4

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x42            ; 'B' Font 5x7
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x32            ; '2' Espacing 2 pixels
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    suite_fin

suite4          movlw   d'04'           ; FONTE 10x14     SPACING 1
                cpfseq  param_5
                goto    suite5

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x43            ; 'C' Font 10x14
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x31            ; '1' Espacing 1 pixels
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    suite_fin

suite5          movlw   d'05'           ; FONTE 10x14     SPACING 2
                cpfseq  param_5
                goto    suite_fin

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x43            ; 'C' Font 10x14
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x32            ; '2' Espacing 2 pixels
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
suite_fin
;--------------- Pointage de la table de caractaires ---------------------------

                

saut1           movlw   d'12'           ; Nb octet
                mulwf   param_3,1       ; Index
                movlw   0x00            ; Valeur adresse LOW
                addwf   PRODL,0         ; Addtionne avec index calcul LOW
                movwf   ADRES_LOW       ; Transfert vers ADRES_LOW
                movlw   0x34            ; Valeur adresse HIGH
                addwf   PRODH,0         ; Addtionne avec index calcul HIGH
                movwf   ADRES_HIGH      ; Transfert vers ADRES_HIGH

                movff   ADRES_HIGH,TBLPTRH  ; Charge Adresse HIGH
                movff   ADRES_LOW,TBLPTRL   ; Charge Adresse LOW
                
;--------------- Affichage chaine de caracteres --------------------------------

                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movff   temp1,param_1	; Transfert parametre X
                call    par_rw0_rs1     ; routine comunication paralelle

                movff   param_2,param_1 ; Transfert parametre Y
                call    par_rw0_rs1     ; routine comunication paralelle

loop2           tblrd*+                 ; lire un octet, pointer sur le suivant
                movff   TABLAT,param_1
                call    par_rw0_rs1     ; routine comunication paralelle

                decfsz  param_4         ; dcrmenter compteur Nb octets
                bra     loop2

;--------------- exit ----------------------------------------------------------

exit            return                  ; retour du sous programme


;*************** TABLE en memoire FLASH ****************************************

;                org     TABLE_CAR
               
;--------------- Fonte Standard ---------

 ;               DATA 0x5359,0x5354,0x454D,0x2020,0x2020,0x2020


;TABEND
		END
