;*******************************************************************************
;  Filename:    Menu_Management.asm                                            *
;                                                                              *
;  Version:  	13/09/2012    V1.0      Version originale                      *
;                                                                              *
;                                                                              *
;  Author:        Philippe DOUILLARD                                           *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                 			                       *
;  Gestion des menus                                                           *
;                                                                              *
;*******************************************************************************

;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
    #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************
	
    extern      Main

;********************** VARIABLES EXTERNES *************************************
    extern      memo1,memo2,memo3,pages,champ,champ_Max

;************************* SOUS ROUTINE ****************************************

PROG            CODE

Management_MENU
                global Management_MENU

;-------------- MENU PAGE 00 ---------------------------------------------------
                movlw   d'00'           ; pages N
                cpfseq  pages
                goto    pages_00_S1     ; Sinon suite

                btfss   memo3,5         ; Test si appui sur MENU+/-
                goto    pages_00_S1

                movlw   d'01'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET champ
                goto    pages_fin
pages_00_S1
;-------------- MENU PAGE 01 ---------------------------------------------------
                movlw   d'01'           ; pages N
                cpfseq  pages
                goto    pages_01_S11    ; Sinon suite
                movlw   d'10'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_01_S11

                movlw   d'00'           ; Champ N0 (<<)
                cpfseq  champ
                goto    pages_01_S1
                movlw   d'01'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_01_S1     movlw   d'01'           ; Champ N1 (EXIT)
                cpfseq  champ
                goto    pages_01_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_01_S2     movlw   d'02'           ; Champ N2 (>>)
                cpfseq  champ
                goto    pages_01_S3
                movlw   d'01'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET champ
                goto    pages_fin

pages_01_S3     movlw   d'03'           ; Champ N3 (LEVEL)
                cpfseq  champ
                goto    pages_01_S4
                movlw   d'11'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET champ
                goto    pages_fin

pages_01_S4     movlw   d'04'           ; Champ N4 (LINEAR)
                cpfseq  champ
                goto    pages_01_S5
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET champ
                goto    pages_fin

pages_01_S5     movlw   d'05'           ; Champ N5 (AUDIO)
                cpfseq  champ
                goto    pages_01_S6
                movlw   d'41'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET champ
                goto    pages_fin

pages_01_S6     movlw   d'06'           ; Champ N6 (LOAD)
                cpfseq  champ
                goto    pages_01_S7
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET champ
                goto    pages_fin

pages_01_S7     movlw   d'07'           ; Champ N7 (SAVE)
                cpfseq  champ
                goto    pages_01_S8
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET champ
                goto    pages_fin

pages_01_S8     movlw   d'08'           ; Champ N8 (RENAME)
                cpfseq  champ
                goto    pages_01_S9
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET champ
                goto    pages_fin

pages_01_S9     movlw   d'09'           ; Champ N9 (HARDWARE)
                cpfseq  champ
                goto    pages_01_S10
                movlw   d'51'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET champ
                goto    pages_fin

pages_01_S10    movlw   d'10'           ; Champ N10 (SYSTEM)
                cpfseq  champ
                goto    pages_01_S11
                movlw   d'31'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET champ
                goto    pages_fin

pages_01_S11
;-------------- MENU PAGE 11 ---------------------------------------------------
                movlw   d'11'           ; pages N
                cpfseq  pages
                goto    pages_11_S3       ; Sinon suite
                movlw   d'04'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_11_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_11_S1
                movlw   d'18'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_11_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_11_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_11_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_11_S3
                movlw   d'12'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_11_S3
;-------------- MENU PAGE 12 ---------------------------------------------------
                movlw   d'12'           ; pages N
                cpfseq  pages
                goto    pages_12_S3       ; Sinon suite
                movlw   d'04'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_12_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_12_S1
                movlw   d'11'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_12_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_12_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_12_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_12_S3
                movlw   d'13'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_12_S3
;-------------- MENU PAGE 13 ---------------------------------------------------
                movlw   d'13'           ; pages N
                cpfseq  pages
                goto    pages_13_S3       ; Sinon suite
                movlw   d'04'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_13_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_13_S1
                movlw   d'12'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_13_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_13_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_13_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_13_S3
                movlw   d'14'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_13_S3
;-------------- MENU PAGE 14 ---------------------------------------------------
                movlw   d'14'           ; pages N
                cpfseq  pages
                goto    pages_14_S3      ; Sinon suite
                movlw   d'04'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_14_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_14_S1
                movlw   d'13'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_14_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_14_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_14_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_14_S3
                movlw   d'15'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_14_S3

;-------------- MENU PAGE 15 ---------------------------------------------------
                movlw   d'15'           ; pages N
                cpfseq  pages
                goto    pages_15_S3      ; Sinon suite
                movlw   d'04'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_15_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_15_S1
                movlw   d'14'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_15_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_15_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_15_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_15_S3
                movlw   d'16'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_15_S3

;-------------- MENU PAGE 16 ---------------------------------------------------
                movlw   d'16'           ; pages N
                cpfseq  pages
                goto    pages_16_S3      ; Sinon suite
                movlw   d'04'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_16_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_16_S1
                movlw   d'15'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_16_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_16_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_16_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_16_S3
                movlw   d'17'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_16_S3

;-------------- MENU PAGE 17 ---------------------------------------------------
                movlw   d'17'           ; pages N
                cpfseq  pages
                goto    pages_17_S3      ; Sinon suite
                movlw   d'04'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_17_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_17_S1
                movlw   d'16'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_17_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_17_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_17_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_17_S3
                movlw   d'18'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_17_S3

;-------------- MENU PAGE 18 ---------------------------------------------------
                movlw   d'18'           ; pages N
                cpfseq  pages
                goto    pages_18_S3      ; Sinon suite
                movlw   d'4'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_18_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_18_S1
                movlw   d'17'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_18_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_18_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_18_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_18_S3
                movlw   d'11'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_18_S3

;-------------- MENU PAGE 31 ---------------------------------------------------
                movlw   d'31'           ; pages N
                cpfseq  pages
                goto    pages_31_S3     ; Sinon suite
                movlw   d'4'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_31_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_31_S1
                movlw   d'38'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_31_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_31_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_31_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_31_S3
                movlw   d'32'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_31_S3

;-------------- MENU PAGE 32 ---------------------------------------------------
                movlw   d'32'           ; pages N
                cpfseq  pages
                goto    pages_32_S3     ; Sinon suite
                movlw   d'4'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_32_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_32_S1
                movlw   d'31'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_32_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_32_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_32_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_32_S3
                movlw   d'33'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_32_S3

;-------------- MENU PAGE 33 ---------------------------------------------------
                movlw   d'33'           ; pages N
                cpfseq  pages
                goto    pages_33_S3     ; Sinon suite
                movlw   d'4'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_33_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_33_S1
                movlw   d'32'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_33_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_33_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_33_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_33_S3
                movlw   d'34'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_33_S3

;-------------- MENU PAGE 34 ---------------------------------------------------
                movlw   d'34'           ; pages N
                cpfseq  pages
                goto    pages_34_S3     ; Sinon suite
                movlw   d'4'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_34_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_34_S1
                movlw   d'33'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_34_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_34_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_34_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_34_S3
                movlw   d'35'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_34_S3

;-------------- MENU PAGE 35 ---------------------------------------------------
                movlw   d'35'           ; pages N
                cpfseq  pages
                goto    pages_35_S3     ; Sinon suite
                movlw   d'4'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_35_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_35_S1
                movlw   d'34'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_35_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_35_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_35_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_35_S3
                movlw   d'36'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_35_S3

;-------------- MENU PAGE 36 ---------------------------------------------------
                movlw   d'36'           ; pages N
                cpfseq  pages
                goto    pages_36_S3     ; Sinon suite
                movlw   d'4'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_36_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_36_S1
                movlw   d'35'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_36_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_36_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_36_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_36_S3
                movlw   d'37'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_36_S3

;-------------- MENU PAGE 37 ---------------------------------------------------
                movlw   d'37'           ; pages N
                cpfseq  pages
                goto    pages_37_S3     ; Sinon suite
                movlw   d'4'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_37_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_37_S1
                movlw   d'36'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_37_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_37_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_37_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_37_S3
                movlw   d'38'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_37_S3

;-------------- MENU PAGE 38 ---------------------------------------------------
                movlw   d'38'           ; pages N
                cpfseq  pages
                goto    pages_38_S3     ; Sinon suite
                movlw   d'4'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_38_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_38_S1
                movlw   d'37'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_38_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_38_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_38_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_38_S3
                movlw   d'31'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_38_S3

;-------------- MENU PAGE 41 ---------------------------------------------------
                movlw   d'41'           ; pages N
                cpfseq  pages
                goto    pages_41_S3     ; Sinon suite
                movlw   d'03'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_41_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_41_S1
                movlw   d'43'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_41_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_41_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_41_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_41_S3
                movlw   d'42'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_41_S3

;-------------- MENU PAGE 42 ---------------------------------------------------
                movlw   d'42'           ; pages N
                cpfseq  pages
                goto    pages_42_S3     ; Sinon suite
                movlw   d'2'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_42_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_42_S1
                movlw   d'41'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_42_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_42_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_42_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_42_S3
                movlw   d'43'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_42_S3

;-------------- MENU PAGE 43 ---------------------------------------------------
                movlw   d'43'           ; pages N
                cpfseq  pages
                goto    pages_43_S3     ; Sinon suite
                movlw   d'2'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_43_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_43_S1
                movlw   d'42'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_43_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_43_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_43_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_43_S3
                movlw   d'41'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_43_S3

;-------------- MENU PAGE 51 ---------------------------------------------------
                movlw   d'51'           ; pages N
                cpfseq  pages
                goto    pages_51_S3      ; Sinon suite
                movlw   d'02'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_51_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_51_S1
                movlw   d'54'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_51_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_51_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_51_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_51_S3
                movlw   d'52'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_51_S3

;-------------- MENU PAGE 52 ---------------------------------------------------
                movlw   d'52'           ; pages N
                cpfseq  pages
                goto    pages_52_S3      ; Sinon suite
                movlw   d'02'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_52_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_52_S1
                movlw   d'51'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_52_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_52_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_52_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_52_S3
                movlw   d'53'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_52_S3

;-------------- MENU PAGE 53 ---------------------------------------------------
                movlw   d'53'           ; pages N
                cpfseq  pages
                goto    pages_53_S3      ; Sinon suite
                movlw   d'02'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_53_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_53_S1
                movlw   d'52'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_53_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_53_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_53_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_53_S3
                movlw   d'54'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_53_S3

;-------------- MENU PAGE 54 ---------------------------------------------------
                movlw   d'54'           ; pages N
                cpfseq  pages
                goto    pages_54_S3     ; Sinon suite
                movlw   d'02'
                movwf   champ_Max       ; Champ_Max

                btfss   memo3,4         ; Test si appui sur SEL+/-
                goto    pages_54_S3

                movlw   d'00'           ; Champ N
                cpfseq  champ
                goto    pages_54_S1
                movlw   d'53'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin

pages_54_S1     movlw   d'01'           ; Champ N
                cpfseq  champ
                goto    pages_54_S2
                movlw   d'00'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                clrf    champ           ; RESET Numero de champ
                goto    pages_fin

pages_54_S2     movlw   d'02'           ; Champ N
                cpfseq  champ
                goto    pages_54_S3
                movlw   d'51'           ; PAGE N
                movwf   pages
                bsf     memo3,0         ; RESET FLAG changement de page
                goto    pages_fin
pages_54_S3

pages_fin
;-------------- Test si Incrementation ---------------BP ON/OFF-----------------
;                btfss   memo1,3         ; Si FM BP ON = 1 -> saut ligne
;                goto    pages_exit       ; SINON GOTO exit
;                incf    pages,1          ; SI OUI incrementation
;                bsf     memo3,0         ; RESET FLAG changement de page
;                clrf    champ          ; RESET Numero de sous champ
;pages_exit
;-------------- Incrementation -----------------------BP ON/OFF-----------------
;
;                movlw   0x00            ; W = 0
;                cpfslt  pages            ; Compare si pages < 0 (W)
;                goto    pages_sup        ; Sinon suite
;                movwf   pages            ; Si pages < 0 Alors pages = 0
;pages_sup        movlw   d'99'            ; W = 5
;                cpfsgt  pages            ; Compare si pages > max (W)
;                goto    pages_suite      ; Sinon suite
;                movlw   d'0'            ; Charge 0
;                movwf   pages            ; Si pages > max Alors pages = min
;pages_suite
;
;-------------- Test si Incrementation ---------------MENU + -------------------
                btfss   memo2,3         ; Si FM MENU+ = 1 -> saut ligne
                goto    champI_exit      ; SINON GOTO exit
                decf    champ,1         ; SI OUI incrementation
                ;bsf    memo3,0
champI_exit
;-------------- Test si Decrementation --------------- MENU - ------------------
                btfss   memo2,5         ; Si FM MENU- = 1 -> saut ligne
                goto    champD_exit      ; SINON GOTO exit
                incf    champ,1         ; SI OUI incrementation
                ;bsf    memo3,0
champD_exit

;-------------- MIN/MAX ------------------------------ CHAMP -------------------

                movlw   0xFF            ; W < 0
                cpfseq  champ           ; Compare si champ < 0 (W)
                goto    champ_sup       ; Sinon suite
                movf    champ_Max,0     ; W = Champ_Max
                movwf   champ           ; Si champ < 0 Alors champ = max
                goto    champ_suite

champ_sup       movf    champ_Max,0     ; W = Champ_Max
                cpfsgt  champ           ; Compare si champ > max (W)
                goto    champ_suite     ; Sinon suite
                movlw   d'0'            ; Charge mini
                movwf   champ           ; Si champ > max Alors champ = min
champ_suite



Exit
;--------------- exit ----------------------------------------------------------
            return              ; retour du sous programme
		
    		END
