;*******************************************************************************
;    Filename:	    dec8_bcd3.asm                                              *
;    Date:       	13/11/2006                                             *
;    File Version:	1.0                                                    *
;                                                                              *
;    Author:        Philippe DOUILLARD                                         *
;*******************************************************************************
;  SUB ROUTINE                                                                 *
;                                 			                       *
;	Entree		param_1		valeur 8 bit 0-255                     *
;                                                                              *
;	Sortie		param_1		Octet BCD centaines                    *
;			param_2		Octet BCD dizaines                     *
;			param_3         Octet BCD unit�es                    *
;                                                                              *
;	Temporaire	temp1 		Pas                                    *
;			temp2		valeur de calculee                     *
;			temp3		--                                     *
;  									       *
;*******************************************************************************


;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
        #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************
	extern temp1, temp2, temp3, param_1,param_2,param_3
	extern Main

;************************* SOUS ROUTINE ****************************************

PROG CODE

dec8_bcd3
                        global dec8_bcd3
;------- PAGE SELECT ----------------------------

			BCF STATUS,5		; Select BANK 0
			BCF STATUS,6		; par defaut

;------- Conversion 8 bit -> BCD ---------------

		;------- centaines -> BCD ---------------			
			clrf temp1	; Pas = 0

            movf    param_1,0	; W = param_1 	(valeur 8 bits)
dec8_bcd3_1		movwf temp2	; temp2 = W	(valeur 8 bits)
			
			incf temp1,1	; Pas = pas+1
			
			movlw 0x64	; W = 100
			subwf temp2,0	; W = temp2 - 100(W)
			btfsc STATUS,C	; Si resultat <0 alors saute
			goto dec8_bcd3_1; SINON boucle
			
			movlw 0x01	; W = 1
			subwf temp1,0	; pas = pas - 1
			movwf param_1	; param_1 = pas (centaines)

		;------- dizaines -> BCD ----------------
			clrf temp1	; Pas = 0
			movf temp2,0	; W = temp2 	(valeur 8 bits)
dec8_bcd3_2		movwf temp2	; temp2 = W	(valeur 8 bits)
			
			incf temp1,1	; Pas = pas+1
			
			movlw 0x0A	; W = 10
			subwf temp2,0	; W = temp2 - 100(W)
			btfsc STATUS,C	; Si résultat <0 alors saute
			goto dec8_bcd3_2; SINON boucle
			
			movlw 0x01	; W = 1
			subwf temp1,0	; pas = pas - 1
			movwf param_2	; param_2 = pas (dizaines)

		;------- unitees -> BCD ----------------
			movf temp2,0	; W = temp2
			movwf param_3	; param_3 = temp2

;------- EXIT -----------------------------------
	      		return          ; retour du sous programme
			
			END
