;*******************************************************************************
;  Filename:    page_AUDIO_BAL.asm                                            *
;                                                                              *
;  Version:  	27/02/2013    V1.0      Version originale                      *
;                                                                              *
;  Author:        Philippe DOUILLARD                                           *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                                                              *
;  Ajustage de la balance droite/Gauche                                        *
;                                                                              *
;*******************************************************************************

;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
        #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************

	extern Main,par_rw0_rs0,par_rw0_rs1,vol255_db_BCD,Delay_short
    extern Commande_CLS,Commande_TEXT,Commande_AREA,Commande_DB

;********************** VARIABLES EXTERNES *************************************

    extern      param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8
    extern      param_9,temp1,temp2,temp3,temp5,memo3
    extern      MASTER_Val,champ,BALANCE

;************************* SOUS ROUTINE ****************************************

PROG            CODE

page_AUDIO_BAL
        global page_AUDIO_BAL

;-------------- Test si rafraichissement ------------------------------------------------
        btfsc   memo3,0         ; Test si changement memu CLS si vrai
        goto    init

        btfss   memo3,1         ; Si FLAG (Rafraichissement)
        goto    exit            ; Simon exit
        goto    affichage


init    call    Commande_CLS
        bcf     memo3,0

;************** AFFICHAGE FOND ECRAN *******************************************

;-------------- Affichage TITRE ------------------------------------------------
        movlw   d'00'           ; X
        movwf   param_1
        movlw   d'05'           ; Y
        movwf   param_2
        movlw   d'49'           ; N Chaine
        movwf   param_3
        movlw   d'12'           ; Nb Caracteres+1
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT
        call    Delay_short

;-------------- LIGNE ----------------------------------------------------------
        movlw   0xF1                ; SET AREA
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs0         ; routine comunication paralelle

        movlw   d'01'               ; X1
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   d'06'               ; Y1
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   d'139'              ; X2
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle
                                                
        movlw   d'06'               ; Y2
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   0x46                ; CMD (Invert Area)
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1
        call    Delay_short

;-------------- Affichage Etiquette ----------------------- RIGHT --------------
        movlw   d'00'           ; X
        movwf   param_1
        movlw   d'17'           ; Y
        movwf   param_2
        movlw   d'51'           ; N Chaine
        movwf   param_3
        movlw   d'05'           ; Nb Caracteres+1
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT
        call    Delay_short

;-------------- Affichage Etiquette ----------------------- (1357) -------------
        movlw   d'00'           ; X
        movwf   param_1
        movlw   d'32'           ; Y
        movwf   param_2
        movlw   d'52'           ; N Chaine
        movwf   param_3
        movlw   d'06'           ; Nb Caracteres+1
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT
        call    Delay_short

;-------------- Affichage Etiquette ----------------------- LEFT ---------------
        movlw   d'120'           ; X
        movwf   param_1
        movlw   d'17'           ; Y
        movwf   param_2
        movlw   d'53'           ; N Chaine
        movwf   param_3
        movlw   d'04'           ; Nb Caracteres+1
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT
        call    Delay_short

;-------------- Affichage Etiquette ----------------------- (2468) -------------
        movlw   d'112'           ; X
        movwf   param_1
        movlw   d'32'           ; Y
        movwf   param_2
        movlw   d'54'           ; N Chaine
        movwf   param_3
        movlw   d'06'           ; Nb Caracteres+1
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT
        call    Delay_short

;-------------- Affichage Etiquette ------------------------- dB ---------------
        movlw   d'85'           ; X
        movwf   param_1
        movlw   d'17'           ; Y
        movwf   param_2
        movlw   d'20'           ; N Chaine
        movwf   param_3
        movlw   d'02'           ; Nb Caracteres+1
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT
        call    Delay_short

;-------------- Cadre exterieur niveau Balance ---------------------------------
                movlw   0xF1                ; SET AREA
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs0         ; routine comunication paralelle

                movlw   d'06'               ; X1
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   d'19'               ; Y1
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   d'133'              ; X2
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   d'24'               ; Y2
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   0x4F                ; CMD (OUTINE BOX)
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1
                call    Delay_short

 ;************** Actualisation des variables ***********************************

affichage       bcf     memo3,1         ; Reset FLAG

;-------------- Effacement zone navigation -------------------------------------
                movlw   d'70'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'139'          ; X2
                movwf   param_3
                movlw   d'05'           ; Y2
                movwf   param_4
                movlw   d'02'           ; CLEAR
                movwf   param_5
                call    Commande_AREA

;-------------- Affichage Barre de NAVIGATION ----------------------------------

                movlw   d'106'          ; X
                movwf   param_1
                movlw   d'05'           ; Y
                movwf   param_2
                movlw   d'11'           ; N Chaine
                movwf   param_3
                movlw   d'08'           ; Nb Caracteres+1
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

;-------------- Affichage volume (-96.0/+31.5 dB) ------------------------------

                movlw   d'70'               ; X
                movwf   param_6
                movlw   d'05'               ; Y
                movwf   param_7
                movlw   d'01'               ; FONTE
                movwf   param_8
                movff   MASTER_Val,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage DES VARIABLES -------------------- BALANCE -----------
                movlw   d'59'               ; X1
                movwf   param_1
                movlw   d'11'               ; Y1
                movwf   param_2
                movlw   d'81'               ; X2
                movwf   param_3
                movlw   d'17'               ; Y2
                movwf   param_4
                movlw   d'02'               ; CLEAR AREA
                movwf   param_5
                call    Commande_AREA

                movlw   d'60'               ; X
                movwf   param_6
                movlw   d'17'               ; Y
                movwf   param_7
                movlw   d'01'               ; FONTE
                movwf   param_8
                movff   BALANCE,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Effacement niveau Balance ---------------------------------
                movlw   0xF1                ; SET AREA
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs0         ; routine comunication paralelle

                movlw   d'07'               ; X1
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   d'20'               ; Y1
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   d'132'              ; X2
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   d'23'               ; Y2
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   0x43                ; CMD (CLEAR Area)
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1
                call    Delay_short

;-------------- Volume niveau Balance ---------------------------------
                movlw   0xF1                ; SET AREA
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs0         ; routine comunication paralelle

                movlw   d'70'               ; X1
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   d'20'               ; Y1
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movff   BALANCE,temp1       ; Variable -> Temp1
                movlw   d'192'              ; point 0 Variable
                subwf   temp1,1             ; temp1 = temp1 - 192
                movlw   d'70'               ; point 0 X
                addwf   temp1,1             ; Temp1 = temp1 + 70
                movff   temp1,param_1       ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   d'23'               ; Y2
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   0x46                ; CMD (FILL Area)
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1
                call    Delay_short

;****************** CADRES DE NAVIGATION ***************************************

        ;------ CHAMP 0 --------------------------------------------------
                movlw   0x00            ; W = 0
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_0     ; Sinon suite

                movlw   d'105'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'110'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_0
        ;------ CHAMP 1 --------------------------------------------------
                movlw   0x01            ; W = 1
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_1     ; Sinon suite

                movlw   d'111'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'132'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_1
        ;------ CHAMP 2 --------------------------------------------------
                movlw   0x02            ; W = 2
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_2     ; Sinon suite

                movlw   d'133'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'139'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_2

       ;------ CHAMP 2 --------------------------------------------------
                movlw   0x03            ; W = 3
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_3     ; Sinon suite

                movlw   d'59'               ; X1
                movwf   param_1
                movlw   d'12'               ; Y1
                movwf   param_2
                movlw   d'81'               ; X2
                movwf   param_3
                movlw   d'17'               ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_3
;------------------ exit -------------------------------------------------------

exit                return                      ; retour du sous programme
                    END