;*******************************************************************************
;  Filename:    page_IO.asm                                                   *
;                                                                              *
;  Version:  	13/09/2012    V1.0      Version originale                      *
;                                                                              *
;  Author:        Philippe DOUILLARD                                           *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                                                              *
;  Affichage des Inputs/Outputs                                                *
;                                                                              *
;*******************************************************************************

;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
        #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************

	extern  Main,par_rw0_rs0,par_rw0_rs1,vol255_db_BCD,Delay_short
    extern  Commande_CLS,Commande_TEXT,Commande_AREA,Commande_DB

;********************** VARIABLES EXTERNES *************************************

    extern      MASTER_Val,MASTER_Max,MASTER_Min
    extern      param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8
    extern      param_9
    extern      temp1,temp2,temp3,temp5,memo3
    extern      champ

;************************* SOUS ROUTINE ****************************************

PROG            CODE

page_IO
        global page_IO

;-------------- Test si rafraichissement ------------------------------------------------
        btfsc   memo3,0         ; Test si changement memu CLS si vrai
        goto    init

        ;btfss   memo3,1         ; Si FLAG (Rafraichissement)
        ;goto    exit            ; Simon exit
        goto    affichage


init    call    Commande_CLS
        call    Delay_short
        bcf     memo3,0

;************** AFFICHAGE FOND ECRAN *******************************************

;-------------- Affichage TITRE ------------------------------------------------

        movlw   d'00'           ; X
        movwf   param_1
        movlw   d'05'           ; Y
        movwf   param_2
        movlw   d'16'           ; N Chaine
        movwf   param_3
        movlw   d'12'           ; Nb Caracteres+1
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT

;-------------- Affichage Masque ------------------------------------------------
        movlw   0xF2            ; SET FONT
        movwf   param_1         ; Transfert parametre
		call    par_rw0_rs0     ; routine comunication paralelle

        movlw   0x41            ; 'B' Font 5x7
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   0xF0            ; SET GRAFIC POSITION
        movwf   param_1         ; Transfert parametre
		call    par_rw0_rs0     ; routine comunication paralelle

		movlw   d'00'            ; X
        movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   d'18'            ; Y
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   0x52            ; Caractere 'R'
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   0x41            ; Caractere 'A'
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   0xF0            ; SET GRAFIC POSITION
        movwf   param_1         ; Transfert parametre
		call    par_rw0_rs0     ; routine comunication paralelle

		movlw   d'00'            ; X
        movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   d'25'            ; Y
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   0x52            ; Caractere 'R'
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   0x42            ; Caractere 'B'
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   0xF0            ; SET GRAFIC POSITION
        movwf   param_1         ; Transfert parametre
		call    par_rw0_rs0     ; routine comunication paralelle

		movlw   d'00'            ; X
        movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   d'32'            ; Y
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   0x52            ; Caractere 'R'
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   0x43            ; Caractere 'C'
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   0xF0            ; SET GRAFIC POSITION
        movwf   param_1         ; Transfert parametre
		call    par_rw0_rs0     ; routine comunication paralelle

		movlw   d'74'            ; X
        movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   d'18'            ; Y
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   0x52            ; Caractere 'R'
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   0x44            ; Caractere 'D'
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   0xF0            ; SET GRAFIC POSITION
        movwf   param_1         ; Transfert parametre
		call    par_rw0_rs0     ; routine comunication paralelle

		movlw   d'74'            ; X
        movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   d'25'           ; Y
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   0x52            ; Caractere 'R'
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   0x45            ; Caractere 'E'
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

;-------------- LIGNE ----------------------------------------------------------
        movlw   0xF1                ; SET AREA
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs0         ; routine comunication paralelle

        movlw   d'00'               ; X1
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   d'06'               ; Y1
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   d'139'              ; X2
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle
                                    ; Y2
        movlw   d'06'
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   0x46                ; CMD (Invert Area)
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1

        call    Delay_short

 ;************** Actualisation des variables ************************************

affichage       bcf     memo3,1         ; Reset FLAG

;-------------- Effacement zone navigation -------------------------------------
                movlw   d'70'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'139'          ; X2
                movwf   param_3
                movlw   d'05'           ; Y2
                movwf   param_4
                movlw   d'02'           ; CLEAR
                movwf   param_5
                call    Commande_AREA

;-------------- Affichage Barre de NAVIGATION ----------------------------------

                movlw   d'106'          ; X
                movwf   param_1
                movlw   d'05'           ; Y
                movwf   param_2
                movlw   d'11'           ; N Chaine
                movwf   param_3
                movlw   d'08'           ; Nb Caracteres+1
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

;-------------- Affichage volume (-96.0/+31.5 dB) ------------------------------

                movlw   d'70'               ; X
                movwf   param_6
                movlw   d'05'               ; Y
                movwf   param_7
                movlw   d'01'               ; FONTE
                movwf   param_8
                movff   MASTER_Val,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage E/S (RA) ---------------------------------------------
                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x42            ; 'B' Font 5x7
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'13'            ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'19'            ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                btfss   PORTA,0
                goto    IO_suite0
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit0
IO_suite0       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

IO_exit0        btfss   PORTA,1
                goto    IO_suite1
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit1
IO_suite1       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit1
                btfss   PORTA,2
                goto    IO_suite2
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit2
IO_suite2       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit2
                btfss   PORTA,3
                goto    IO_suite3
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit3
IO_suite3       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit3
                btfss   PORTA,4
                goto    IO_suite4
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit4
IO_suite4       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit4
                btfss   PORTA,5
                goto    IO_suite5
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit5
IO_suite5       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit5
                movlw   0xA5            ; Caractere 'X'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xA5            ; Caractere 'X'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
;-------------- Affichage E/S (RB) ---------------------------------------------
                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'13'            ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'26'            ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                btfss   PORTB,0
                goto    IO_suite10
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit10
IO_suite10      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

IO_exit10       btfss   PORTB,1
                goto    IO_suite11
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit11
IO_suite11       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit11
                btfss   PORTB,2
                goto    IO_suite12
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit12
IO_suite12       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit12
                btfss   PORTB,3
                goto    IO_suite13
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit13
IO_suite13       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit13
                btfss   PORTB,4
                goto    IO_suite14
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit14
IO_suite14       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit14
                btfss   PORTB,5
                goto    IO_suite15
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit15
IO_suite15      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit15
                btfss   PORTB,6
                goto    IO_suite16
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit16
IO_suite16       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit16

                btfss   PORTB,7
                goto    IO_suite17
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit17
IO_suite17       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit17

;-------------- Affichage E/S (RC) ---------------------------------------------

                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'13'            ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'33'            ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                btfss   PORTC,0
                goto    IO_suite20
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit20
IO_suite20       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

IO_exit20        btfss   PORTC,1
                goto    IO_suite21
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit21
IO_suite21       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit21
                btfss   PORTC,2
                goto    IO_suite22
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit22
IO_suite22       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit22
                btfss   PORTC,3
                goto    IO_suite23
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit23
IO_suite23       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit23
                btfss   PORTC,4
                goto    IO_suite24
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit24
IO_suite24       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit24
                btfss   PORTC,5
                goto    IO_suite25
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit25
IO_suite25       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit25
                btfss   PORTC,6
                goto    IO_suite26
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit26
IO_suite26       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit26

                btfss   PORTC,7
                goto    IO_suite27
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit27
IO_suite27      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit27

;-------------- Affichage E/S (RD) ---------------------------------------------

                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'86'            ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'19'            ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                btfss   LATD,0
                goto    IO_suite30
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit30
IO_suite30       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

IO_exit30       btfss   LATD,1
                goto    IO_suite31
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit31
IO_suite31      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit31
                btfss   LATD,2
                goto    IO_suite32
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit32
IO_suite32       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit32
                btfss   LATD,3
                goto    IO_suite33
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit33
IO_suite33       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit33
                btfss   LATD,4
                goto    IO_suite34
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit34
IO_suite34       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit34
                btfss   LATD,5
                goto    IO_suite35
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit35
IO_suite35       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit35
                btfss   LATD,6
                goto    IO_suite36
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit36
IO_suite36       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit36

                btfss   LATD,7
                goto    IO_suite37
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit37
IO_suite37      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit37

;-------------- Affichage E/S (RE) ---------------------------------------------

                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'86'            ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'26'            ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                btfss   LATE,0
                goto    IO_suite40
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit40
IO_suite40       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

IO_exit40       btfss   LATE,1
                goto    IO_suite41
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit41
IO_suite41       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit41
                btfss   LATE,2
                goto    IO_suite42
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit42
IO_suite42       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit42

                movlw   0xA5            ; Caractere 'X'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xA5            ; Caractere 'X'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xA5            ; Caractere 'X'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xA5            ; Caractere 'X'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xA5            ; Caractere 'X'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

;****************** CADRES DE NAVIGATION ***************************************

        ;------ CHAMP 0 --------------------------------------------------
                movlw   0x00            ; W = 0
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_0     ; Sinon suite

                movlw   d'105'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'110'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_0
        ;------ CHAMP 1 --------------------------------------------------
                movlw   0x01            ; W = 1
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_1     ; Sinon suite

                movlw   d'111'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'132'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_1
        ;------ CHAMP 2 --------------------------------------------------
                movlw   0x02            ; W = 2
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_2     ; Sinon suite

                movlw   d'133'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'139'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_2
;------------------ exit -------------------------------------------------------

exit                return                      ; retour du sous programme
                    END