;*******************************************************************************
;  Filename:    page_IO.asm                                                   *
;                                                                              *
;  Version:  	13/09/2012    V1.0      Version originale                      *
;                                                                              *
;  Author:        Philippe DOUILLARD                                           *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                                                              *
;  Affichage des Inputs/Outputs                                                *
;                                                                              *
;*******************************************************************************

;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
        #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************

	extern Main,par_rw0_rs0,par_rw0_rs1,vol255_db_BCD,Delay_short
    extern Commande_CLS,Commande_TEXT,Commande_AREA,Commande_DB

;********************** VARIABLES EXTERNES *************************************

    extern      MASTER_Val,MASTER_Max,MASTER_Min
    extern      param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8
    extern      param_9
    extern      temp1,temp2,temp3,temp5,memo3
    extern      EXP_IN,EXP_OUT,champ

;************************* SOUS ROUTINE ****************************************

PROG            CODE

page_IO_EXP
        global page_IO_EXP

;-------------- Test si rafraichissement ------------------------------------------------
        btfsc   memo3,0         ; Test si changement memu CLS si vrai
        goto    init

        ;btfss   memo3,1         ; Si FLAG (Rafraichissement)
        ;goto    exit            ; Simon exit
        goto    affichage


init    call    Commande_CLS
        bcf     memo3,0

;************** AFFICHAGE FOND ECRAN *******************************************

;-------------- Affichage TITRE ------------------------------------------------
        movlw   d'00'           ; X
        movwf   param_1
        movlw   d'05'           ; Y
        movwf   param_2
        movlw   d'12'           ; N Chaine
        movwf   param_3
        movlw   d'12'           ; Nb Caracteres+1
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT
        call    Delay_short
;-------------- Affichage Masque --------------------------- IN ----------------
        movlw   d'00'           ; X
        movwf   param_1
        movlw   d'18'           ; Y
        movwf   param_2
        movlw   d'13'           ; N Chaine
        movwf   param_3
        movlw   d'03'           ; Nb Caracteres+1
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT

;-------------- Affichage Masque --------------------------- OUT ---------------
        movlw   d'00'           ; X
        movwf   param_1
        movlw   d'25'           ; Y
        movwf   param_2
        movlw   d'14'           ; N Chaine
        movwf   param_3
        movlw   d'04'           ; Nb Caracteres+1
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT

;-------------- LIGNE ----------------------------------------------------------
        movlw   0xF1                ; SET AREA
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs0         ; routine comunication paralelle

        movlw   d'01'               ; X1
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   d'06'               ; Y1
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   d'139'              ; X2
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle
                                                
        movlw   d'06'               ; Y2
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   0x46                ; CMD (Invert Area)
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1
        call    Delay_short

 ;************** Actualisation des variables ************************************

affichage       bcf     memo3,1         ; Reset FLAG
;-------------- Effacement zone navigation -------------------------------------
                movlw   d'70'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'139'          ; X2
                movwf   param_3
                movlw   d'05'           ; Y2
                movwf   param_4
                movlw   d'02'           ; CLEAR
                movwf   param_5
                call    Commande_AREA

;-------------- Affichage Barre de NAVIGATION ----------------------------------

                movlw   d'106'          ; X
                movwf   param_1
                movlw   d'05'           ; Y
                movwf   param_2
                movlw   d'11'           ; N Chaine
                movwf   param_3
                movlw   d'08'           ; Nb Caracteres+1
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

;-------------- Affichage volume (-96.0/+31.5 dB) ------------------------------

                movlw   d'70'               ; X
                movwf   param_6
                movlw   d'05'               ; Y
                movwf   param_7
                movlw   d'01'               ; FONTE
                movwf   param_8
                movff   MASTER_Val,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage E/S (IN) ---------------------------------------------
                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x42            ; 'B' Font 5x7
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'18'           ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'19'           ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                btfss   EXP_IN,0
                goto    IO_suite0
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit0
IO_suite0       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

IO_exit0        btfss   EXP_IN,1
                goto    IO_suite1
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit1
IO_suite1       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit1
                btfss   EXP_IN,2
                goto    IO_suite2
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit2
IO_suite2       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit2
                btfss   EXP_IN,3
                goto    IO_suite3
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit3
IO_suite3       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit3
                btfss   EXP_IN,4
                goto    IO_suite4
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit4
IO_suite4       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit4
                btfss   EXP_IN,5
                goto    IO_suite5
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit5
IO_suite5       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit5
                btfss   EXP_IN,6
                goto    IO_suite6
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit6
IO_suite6       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit6
                btfss   EXP_IN,7
                goto    IO_suite7
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit7
IO_suite7       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit7
;-------------- Affichage E/S (OUT) --------------------------------------------
                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'18'            ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'26'            ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                btfss   EXP_OUT,0
                goto    IO_suite10
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit10
IO_suite10      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

IO_exit10       btfss   EXP_OUT,1
                goto    IO_suite11
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit11
IO_suite11      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit11
                btfss   EXP_OUT,2
                goto    IO_suite12
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit12
IO_suite12      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit12
                btfss   EXP_OUT,3
                goto    IO_suite13
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit13
IO_suite13       movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit13
                btfss   EXP_OUT,4
                goto    IO_suite14
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit14
IO_suite14      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit14
                btfss   EXP_OUT,5
                goto    IO_suite15
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit15
IO_suite15      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit15
                btfss   EXP_OUT,6
                goto    IO_suite16
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit16
IO_suite16      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit16

                btfss   EXP_OUT,7
                goto    IO_suite17
                movlw   0x94            ; Caractere ON
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    IO_exit17
IO_suite17      movlw   0x95            ; Caractere OFF
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
IO_exit17

;****************** CADRES DE NAVIGATION ***************************************

        ;------ CHAMP 0 --------------------------------------------------
                movlw   0x00            ; W = 0
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_0     ; Sinon suite

                movlw   d'105'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'110'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_0
        ;------ CHAMP 1 --------------------------------------------------
                movlw   0x01            ; W = 1
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_1     ; Sinon suite

                movlw   d'111'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'132'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_1
        ;------ CHAMP 2 --------------------------------------------------
                movlw   0x02            ; W = 2
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_2     ; Sinon suite

                movlw   d'133'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'139'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_2
;------------------ exit -------------------------------------------------------

exit                return                      ; retour du sous programme
                    END