;*******************************************************************************
;  Filename:    page_Menu.asm                                                   *
;                                                                              *
;  Version:  	21/02/2013    V1.0      Version originale                      *
;                                                                              *
;  Author:        Philippe DOUILLARD                                           *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                                                              *
;  Affichage de la page Menu                                                    *
;                                                                              *
;*******************************************************************************

;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
        #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************

	extern  Main,par_rw0_rs0,par_rw0_rs1,vol255_db_BCD,Delay_short
    extern  Commande_CLS,Commande_TEXT,Commande_AREA,Commande_DB

;********************** VARIABLES EXTERNES *************************************

    extern      MASTER_Val,MASTER_Max,MASTER_Min
    extern      param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8
    extern      param_9,memo1,memo3,temp1,temp2,temp3,temp5,temp6,temp7
    extern      pages,champ

;************************* SOUS ROUTINE ****************************************

PROG    CODE

page_Menu
        global  page_Menu

;-------------- Test si rafraichissement ------------------------------------------------
        btfsc   memo3,0         ; Test si changement memu CLS si vrai
        goto    init

        btfss   memo3,1         ; Si FLAG (Rafraichissement)
        goto    exit            ; Simon exit
        goto    affichage


init    call    Commande_CLS
        bcf     memo3,0

;************** AFFICHAGE FOND ECRAN *******************************************

;-------------- Affichage TITRE ------------------------------------------------
        
        movlw   d'00'           ; X
        movwf   param_1
        movlw   d'05'           ; Y
        movwf   param_2
        movlw   d'03'           ; N Chaine
        movwf   param_3
        movlw   d'06'           ; Nb Caracteres
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT

        movff   pages,temp1     ; Sauve N Page
        movlw   d'00'           ;
        subwf   temp1,1         ; N Page - 00
        movlw   d'48'           ; Chiffre 0
        addwf   temp1           ; N Page + caractere 0
		movff   temp1,param_1   ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   0x2F            ; Caractere '/'
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   0x31            ; Caractere '1'
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle


;-------------- LIGNE ----------------------------------------------------------

        movlw   0xF1                ; SET AREA
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs0         ; routine comunication paralelle

        movlw   d'00'               ; X1
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   d'06'               ; Y1
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   d'139'               ; X2
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   d'06'               ; Y2
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   0x46                ; CMD (Invert Area)
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1
        call    Delay_short

;************** Actualisation des variables ************************************

affichage       bcf     memo3,1         ; Reset FLAG
                
;-------------- Effacement zone navigation -------------------------------------
                movlw   d'70'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'139'          ; X2
                movwf   param_3
                movlw   d'05'           ; Y2
                movwf   param_4
                movlw   d'02'           ; CLEAR
                movwf   param_5
                call    Commande_AREA
                
;-------------- Affichage Barre de NAVIGATION ----------------------------------

                movlw   d'106'          ; X
                movwf   param_1
                movlw   d'05'           ; Y
                movwf   param_2
                movlw   d'11'           ; N Chaine
                movwf   param_3
                movlw   d'08'           ; Nb Caracteres+1
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

;-------------- Affichage volume (-96.0/+31.5 dB) ------------------------------

                movlw   d'70'               ; X
                movwf   param_6
                movlw   d'05'               ; Y
                movwf   param_7
                movlw   d'01'               ; FONTE
                movwf   param_8
                movff   MASTER_Val,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Affichage vignettes MENU 1 -------------------------------------
                movlw   d'00'               ; X1
                movwf   param_1
                movlw   d'08'               ; Y1
                movwf   param_2
                movlw   d'46'               ; X2
                movwf   param_3
                movlw   d'15'               ; Y2
                movwf   param_4
                movlw   d'02'               ; CLEAR
                movwf   param_5
                call    Commande_AREA

                movlw   d'01'               ; X
                movwf   param_1
                movlw   d'15'               ; Y
                movwf   param_2
                movlw   d'04'               ; N Chaine
                movwf   param_3
                movlw   d'05'               ; Nb Caracteres
                movwf   param_4
                movlw   d'01'               ; Fonte
                movwf   param_5
                call    Commande_TEXT

;-------------- Affichage vignettes MENU 2 -------------------------------------
                movlw   d'00'               ; X1
                movwf   param_1
                movlw   d'17'               ; Y1
                movwf   param_2
                movlw   d'46'               ; X2
                movwf   param_3
                movlw   d'23'               ; Y2
                movwf   param_4
                movlw   d'02'               ; CLEAR
                movwf   param_5
                call    Commande_AREA

                movlw   d'01'               ; X
                movwf   param_1
                movlw   d'23'               ; Y
                movwf   param_2
                movlw   d'05'               ; N Chaine
                movwf   param_3
                movlw   d'06'               ; Nb Caracteres
                movwf   param_4
                movlw   d'01'               ; Fonte
                movwf   param_5
                call    Commande_TEXT

;-------------- Affichage vignettes MENU 3 -------------------------------------
                movlw   d'00'               ; X1
                movwf   param_1
                movlw   d'25'               ; Y1
                movwf   param_2
                movlw   d'46'               ; X2
                movwf   param_3
                movlw   d'31'               ; Y2
                movwf   param_4
                movlw   d'02'               ; CLEAR
                movwf   param_5
                call    Commande_AREA

                movlw   d'01'               ; X
                movwf   param_1
                movlw   d'31'               ; Y
                movwf   param_2
                movlw   d'06'               ; N Chaine
                movwf   param_3
                movlw   d'05'               ; Nb Caracteres
                movwf   param_4
                movlw   d'01'               ; Fonte
                movwf   param_5
                call    Commande_TEXT

;-------------- Affichage vignettes MENU 4 -------------------------------------
                movlw   d'46'               ; X1
                movwf   param_1
                movlw   d'08'               ; Y1
                movwf   param_2
                movlw   d'92'               ; X2
                movwf   param_3
                movlw   d'15'               ; Y2
                movwf   param_4
                movlw   d'02'               ; CLEAR
                movwf   param_5
                call    Commande_AREA

                movlw   d'47'               ; X
                movwf   param_1
                movlw   d'15'               ; Y
                movwf   param_2
                movlw   d'07'               ; N Chaine
                movwf   param_3
                movlw   d'04'               ; Nb Caracteres
                movwf   param_4
                movlw   d'01'               ; Fonte
                movwf   param_5
                call    Commande_TEXT

;-------------- Affichage vignettes MENU 5 -------------------------------------
                movlw   d'46'           ; X1
                movwf   param_1
                movlw   d'17'           ; Y1
                movwf   param_2
                movlw   d'92'          ; X2
                movwf   param_3
                movlw   d'23'           ; Y2
                movwf   param_4
                movlw   d'02'           ; CLEAR
                movwf   param_5
                call    Commande_AREA

                movlw   d'47'               ; X
                movwf   param_1
                movlw   d'23'               ; Y
                movwf   param_2
                movlw   d'08'               ; N Chaine
                movwf   param_3
                movlw   d'04'               ; Nb Caracteres
                movwf   param_4
                movlw   d'01'               ; Fonte
                movwf   param_5
                call    Commande_TEXT

;-------------- Affichage vignettes MENU 6 -------------------------------------
                movlw   d'46'               ; X1
                movwf   param_1
                movlw   d'25'               ; Y1
                movwf   param_2
                movlw   d'92'               ; X2
                movwf   param_3
                movlw   d'31'               ; Y2
                movwf   param_4
                movlw   d'02'               ; CLEAR
                movwf   param_5
                call    Commande_AREA

                movlw   d'47'               ; X
                movwf   param_1
                movlw   d'31'               ; Y
                movwf   param_2
                movlw   d'09'               ; N Chaine
                movwf   param_3
                movlw   d'06'               ; Nb Caracteres
                movwf   param_4
                movlw   d'01'               ; Fonte
                movwf   param_5
                call    Commande_TEXT

;-------------- Affichage vignettes MENU 7 -------------------------------------
                movlw   d'92'               ; X1
                movwf   param_1
                movlw   d'08'               ; Y1
                movwf   param_2
                movlw   d'139'              ; X2
                movwf   param_3
                movlw   d'15'               ; Y2
                movwf   param_4
                movlw   d'02'               ; CLEAR
                movwf   param_5
                call    Commande_AREA

                movlw   d'93'               ; X
                movwf   param_1
                movlw   d'15'               ; Y
                movwf   param_2
                movlw   d'10'               ; N Chaine
                movwf   param_3
                movlw   d'08'               ; Nb Caracteres
                movwf   param_4
                movlw   d'01'               ; Fonte
                movwf   param_5
                call    Commande_TEXT

;-------------- Affichage vignettes MENU 8 -------------------------------------
                movlw   d'92'               ; X1
                movwf   param_1
                movlw   d'17'               ; Y1
                movwf   param_2
                movlw   d'139'              ; X2
                movwf   param_3
                movlw   d'23'               ; Y2
                movwf   param_4
                movlw   d'02'               ; CLEAR
                movwf   param_5
                call    Commande_AREA

                movlw   d'93'               ; X
                movwf   param_1
                movlw   d'23'               ; Y
                movwf   param_2
                movlw   d'00'               ; N Chaine
                movwf   param_3
                movlw   d'06'               ; Nb Caracteres
                movwf   param_4
                movlw   d'01'               ; Fonte
                movwf   param_5
                call    Commande_TEXT

;****************** CADRES DE NAVIGATION ***************************************

        ;------ CHAMP 0 --------------------------------------------------
                movlw   0x00            ; W = 0
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_0     ; Sinon suite

                movlw   d'105'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'110'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_0
        ;------ CHAMP 1 --------------------------------------------------
                movlw   0x01            ; W = 1
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_1     ; Sinon suite
 
                movlw   d'111'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'132'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_1
        ;------ CHAMP 2 --------------------------------------------------
                movlw   0x02            ; W = 2
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_2     ; Sinon suite

                movlw   d'133'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'139'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_2
        ;------ CHAMP 3 --------------------------------------------------
                movlw   0x03            ; W = 3
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_3     ; Sinon suite

                movlw   d'00'           ; X1
                movwf   param_1
                movlw   d'09'           ; Y1
                movwf   param_2
                movlw   d'40'          ; X2
                movwf   param_3
                movlw   d'15'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_3
        ;------ CHAMP 4 --------------------------------------------------
                movlw   0x04            ; W = 4
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_4     ; Sinon suite

                movlw   d'00'           ; X1
                movwf   param_1
                movlw   d'17'           ; Y1
                movwf   param_2
                movlw   d'40'           ; X2
                movwf   param_3
                movlw   d'23'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_4

        ;------ CHAMP 5 --------------------------------------------------
                movlw   0x05            ; W = 0
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_5     ; Sinon suite

                movlw   d'00'           ; X1
                movwf   param_1
                movlw   d'25'           ; Y1
                movwf   param_2
                movlw   d'40'           ; X2
                movwf   param_3
                movlw   d'31'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_5

        ;------ CHAMP 6 --------------------------------------------------
                movlw   0x06            ; W = 0
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_6     ; Sinon suite

                movlw   d'46'           ; X1
                movwf   param_1
                movlw   d'09'           ; Y1
                movwf   param_2
                movlw   d'86'           ; X2
                movwf   param_3
                movlw   d'15'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_6

        ;------ CHAMP 7 --------------------------------------------------
                movlw   0x07            ; W = 0
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_7     ; Sinon suite

                movlw   d'46'           ; X1
                movwf   param_1
                movlw   d'17'           ; Y1
                movwf   param_2
                movlw   d'86'           ; X2
                movwf   param_3
                movlw   d'23'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_7

        ;------ CHAMP 8 --------------------------------------------------
                movlw   0x08            ; W = 0
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_8     ; Sinon suite

                movlw   d'46'           ; X1
                movwf   param_1
                movlw   d'25'           ; Y1
                movwf   param_2
                movlw   d'86'           ; X2
                movwf   param_3
                movlw   d'31'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_8

        ;------ CHAMP 9 --------------------------------------------------
                movlw   0x09            ; W = 0
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_9     ; Sinon suite

                movlw   d'92'           ; X1
                movwf   param_1
                movlw   d'09'           ; Y1
                movwf   param_2
                movlw   d'136'           ; X2
                movwf   param_3
                movlw   d'15'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_9

        ;------ CHAMP 10 --------------------------------------------------
                movlw   0x0A            ; W = 0
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_10     ; Sinon suite

                movlw   d'92'           ; X1
                movwf   param_1
                movlw   d'17'           ; Y1
                movwf   param_2
                movlw   d'136'           ; X2
                movwf   param_3
                movlw   d'23'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_10

;------------------ exit -------------------------------------------------------

exit                return                      ; retour du sous programme
                    END

