;*******************************************************************************
;  Filename:    page_OUT.asm                                                   *
;                                                                              *
;  Version:  	13/09/2012    V1.0      Version originale                      *
;                                                                              *
;  Author:        Philippe DOUILLARD                                           *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                                                              *
;  Affichage de la page OUT                                                    *
;                                                                              *
;*******************************************************************************

;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
        #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************

	extern  Main,par_rw0_rs0,par_rw0_rs1,vol255_db_BCD,Delay_short
    EXTERN  Commande_CLS,Commande_TEXT,Commande_AREA,Commande_DB

;********************** VARIABLES EXTERNES *************************************

    extern      MASTER_Val,MASTER_Max,MASTER_Min
    extern      param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8
    extern      param_9
    extern      memo1,memo3,temp1,temp2,temp3,temp5,temp6,temp7
    extern      pages,champ
    extern      OFFSET_1,OFFSET_2,OFFSET_3,OFFSET_4,OFFSET_5,OFFSET_6
    extern      OFFSET_7,OFFSET_8,OFFSET_Min,OFFSET_Max
    extern      MAX_1,MAX_2,MAX_3,MAX_4,MAX_5,MAX_6,MAX_7,MAX_8
    extern      MAX_Min,MAX_Max

;************************* SOUS ROUTINE ****************************************

PROG            CODE

page_OUT
        global page_OUT

;-------------- Test si rafraichissement ------------------------------------------------
        btfsc   memo3,0         ; Test si changement memu CLS si vrai
        goto    init

        btfss   memo3,1         ; Si FLAG (Rafraichissement)
        goto    exit            ; Simon exit
        goto    affichage


init    call    Commande_CLS
        call    Delay_short
        bcf     memo3,0

;************** AFFICHAGE FOND ECRAN *******************************************

;-------------- Affichage TITRE ------------------------------------------------
        
        movlw   d'00'           ; X
        movwf   param_1
        movlw   d'05'           ; Y
        movwf   param_2
        movlw   d'17'           ; N Chaine
        movwf   param_3
        movlw   d'11'           ; Nb Caracteres
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT

        movff   pages,temp1     ; Sauve N Page
        movlw   d'10'           ;
        subwf   temp1,1         ; N Page - 10
        movlw   d'48'           ; Chiffre 0
        addwf   temp1           ; N Page + caractere 0
		movff   temp1,param_1   ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   0x2F            ; Caractere '/'
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

        movlw   0x38            ; Caractere '8'
		movwf   param_1         ; Transfert parametre
		call    par_rw0_rs1     ; routine comunication paralelle

;-------------- Affichage vignettes MAX-----------------------------------------

        movlw   d'40'           ; X
        movwf   param_1
        movlw   d'18'           ; Y
        movwf   param_2
        movlw   d'18'           ; N Chaine
        movwf   param_3
        movlw   d'03'           ; Nb Caracteres
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT

;-------------- Affichage vignettes dB MAX -------------------------------------

        movlw   d'95'           ; X
        movwf   param_1
        movlw   d'18'           ; Y
        movwf   param_2
        movlw   d'20'           ; N Chaine
        movwf   param_3
        movlw   d'02'           ; Nb Caracteres
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT

;-------------- Affichage vignettes OFFSET -------------------------------------

        movlw   d'25'           ; X
        movwf   param_1
        movlw   d'31'           ; Y
        movwf   param_2
        movlw   d'19'           ; N Chaine
        movwf   param_3
        movlw   d'06'           ; Nb Caracteres
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT

;-------------- Affichage vignettes dB OFFSET ----------------------------------

        movlw   d'95'           ; X
        movwf   param_1
        movlw   d'31'           ; Y
        movwf   param_2
        movlw   d'20'           ; N Chaine
        movwf   param_3
        movlw   d'02'           ; Nb Caracteres
        movwf   param_4
        movlw   d'01'           ; Fonte
        movwf   param_5
        call    Commande_TEXT

;-------------- LIGNE ----------------------------------------------------------

        movlw   0xF1                ; SET AREA
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs0         ; routine comunication paralelle

        movlw   d'00'               ; X1
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   d'06'               ; Y1
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   d'139'               ; X2
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   d'06'               ; Y2
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1         ; routine comunication paralelle

        movlw   0x46                ; CMD (Invert Area)
        movwf   param_1             ; Transfert parametre
        call    par_rw0_rs1
        call    Delay_short

;************** Actualisation des variables ************************************

affichage       bcf     memo3,1         ; Reset FLAG
                
;-------------- Effacement zone navigation -------------------------------------
                movlw   d'70'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'139'          ; X2
                movwf   param_3
                movlw   d'05'           ; Y2
                movwf   param_4
                movlw   d'02'           ; CLEAR
                movwf   param_5
                call    Commande_AREA

;-------------- Affichage Barre de NAVIGATION ----------------------------------

                movlw   d'106'          ; X
                movwf   param_1
                movlw   d'05'           ; Y
                movwf   param_2
                movlw   d'11'           ; N Chaine
                movwf   param_3
                movlw   d'08'           ; Nb Caracteres+1
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT
            
;-------------- Affichage volume (-96.0/+31.5 dB) ------------------------------

                movlw   d'70'               ; X
                movwf   param_6
                movlw   d'05'               ; Y
                movwf   param_7
                movlw   d'01'               ; FONTE
                movwf   param_8
                movff   MASTER_Val,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Cadre Exterieur ------------------------------------------------

                    movlw   d'00'               ; X1
                    movwf   param_1
                    movlw   d'12'               ; Y1
                    movwf   param_2
                    movlw   d'04'               ; X2
                    movwf   param_3
                    movlw   d'28'               ; Y2
                    movwf   param_4
                    movlw   d'03'               ; Outline Box
                    movwf   param_5
                    call    Commande_AREA

;--------------- Niveau (Effacement interieur) ---------------------------------

                    movlw   0xF1                ; SET AREA
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs0         ; routine comunication paralelle

                    movlw   d'01'                ; X1
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movlw   d'13'               ; Y1
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movlw   d'03'               ; X2
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movff   MASTER_Val,param_1  ; Y2
                    bcf     STATUS,C            ; Efface la Carry
                    RRCF    param_1             ; Divise par 2
                    bcf     STATUS,C            ; Efface la Carry
                    RRCF    param_1             ; Divise par 2
                    bcf     STATUS,C            ; Efface la Carry
                    RRCF    param_1             ; Divise par 2
                    bcf     STATUS,C            ; Efface la Carry
                    RRCF    param_1             ; Divise par 2
                    bcf     STATUS,C            ; Efface la Carry
                    movlw   d'28'
                    subfwb  param_1
                    movff   param_1,param_2
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movlw   0x43                ; CMD (Clear Area)
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

;-------------- Niveau mobil ---------------------------------------------------

                    movlw   0xF1                ; SET AREA
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs0         ; routine comunication paralelle

                    movlw   d'01'               ; X1
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movff   MASTER_Val,param_1 ; Y1
                    bcf     STATUS,C           ; Efface la Carry
                    RRCF    param_1            ; Divise par 2
                    bcf     STATUS,C           ; Efface la Carry
                    RRCF    param_1            ; Divise par 2
                    bcf     STATUS,C           ; Efface la Carry
                    RRCF    param_1            ; Divise par 2
                    bcf     STATUS,C           ; Efface la Carry
                    RRCF    param_1            ; Divise par 2
                    bcf     STATUS,C           ; Efface la Carry
                    movlw   d'28'
                    subfwb  param_1
                    movff   param_1,param_2
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movlw   d'03'               ; X2
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle
                    movlw   d'28'               ; Y2
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movlw   0x46                ; CMD (Fill Area)
                    movwf    param_1            ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

;------------------ Niveau (Ligne curseur Max) ---------------------------------

                    movlw   0xF1                ; SET AREA
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs0         ; routine comunication paralelle

                    movlw   d'01'               ; X1
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movff   MASTER_Max,param_1	; Y1
                    bcf     STATUS,C
                    RRCF    param_1
                    bcf     STATUS,C
                    RRCF    param_1
                    bcf     STATUS,C
                    RRCF    param_1
                    bcf     STATUS,C
                    RRCF    param_1
                    bcf     STATUS,C
                    movlw   d'28'
                    subfwb  param_1
                    movff   param_1,param_2
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movlw   d'03'               ; X2
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                                                ; Y2
                    movff   param_2,param_1     ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movlw   0x49                ; CMD (Invert Area)
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle


;------------------ Niveau (Fleche curseur Max) --------------------------------
                    movlw   0xF2                ; SET FONT
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs0         ; routine comunication paralelle

                    movlw   0x42                ; 'B' Font 5x7
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movlw   0xF0                ; SET GRAFIC POSITION
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs0         ; routine comunication paralelle

                    movlw   d'06'               ; X
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                                                ; Y
                    movff   param_2,param_1     ; Transfert parametre
                    movlw   0x04
                    addwf   param_1
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movlw   0x1E                ; 'fleche'
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

;------------------ Pointeur (Ligne curseur Max) ---------------------------------

                    movlw   0xF1                ; SET AREA
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs0         ; routine comunication paralelle

                    movlw   d'08'               ; X1
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movff   param_2,param_1     ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movlw   d'35'               ; X2
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                                                ; Y2
                    movff   param_2,param_1     ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movlw   0x46                ; CMD (FILL Area)
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

;------------------ Niveau (Fleche curseur Min) --------------------------------
                    movlw   0xF2                ; SET FONT
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs0         ; routine comunication paralelle

                    movlw   0x42                ; 'B' Font 5x7
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movlw   0xF0                ; SET GRAFIC POSITION
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs0         ; routine comunication paralelle

                    movlw   d'06'               ; X
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movff   MASTER_Min,param_1	; Y1
                    bcf     STATUS,C
                    RRCF    param_1
                    bcf     STATUS,C
                    RRCF    param_1
                    bcf     STATUS,C
                    RRCF    param_1
                    bcf     STATUS,C
                    RRCF    param_1
                    bcf     STATUS,C
                    movlw   d'28'
                    subfwb  param_1
                    movlw   0x06
                    addwf   param_1
                    movff   param_1,param_2
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movlw   0x1E                ; 'fleche'
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle
;------------------ Pointeur (Ligne curseur Min) -------------------------------

                    movlw   0xF1                ; SET AREA
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs0         ; routine comunication paralelle

                    movlw   d'08'               ; X1
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movlw   0x04
                    subwf   param_2
                    movff   param_2,param_1     ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movlw   d'19'               ; X2
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movff   param_2,param_1     ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

                    movlw   0x46                ; CMD (Invert Area)
                    movwf   param_1             ; Transfert parametre
                    call    par_rw0_rs1         ; routine comunication paralelle

;-------------- Selection des variables ----------------------------------------
page_11         movlw   d'11'           ; Page N
                cpfseq  pages
                goto    page_12         ; Sinon suite
                movff   OFFSET_1,temp7
                movff   MAX_1,temp6

page_12         movlw   d'12'           ; Page N
                cpfseq  pages
                goto    page_13         ; Sinon suite
                movff   OFFSET_2,temp7
                movff   MAX_2,temp6

page_13         movlw   d'13'           ; Page N
                cpfseq  pages
                goto    page_14         ; Sinon suite
                movff   OFFSET_3,temp7
                movff   MAX_3,temp6

page_14         movlw   d'14'           ; Page N
                cpfseq  pages
                goto    page_15         ; Sinon suite
                movff   OFFSET_4,temp7
                movff   MAX_4,temp6

page_15         movlw   d'15'           ; Page N
                cpfseq  pages
                goto    page_16         ; Sinon suite
                movff   OFFSET_5,temp7
                movff   MAX_5,temp6

page_16         movlw   d'16'           ; Page N
                cpfseq  pages
                goto    page_17         ; Sinon suite
                movff   OFFSET_6,temp7
                movff   MAX_6,temp6

page_17         movlw   d'17'           ; Page N
                cpfseq  pages
                goto    page_18         ; Sinon suite
                movff   OFFSET_7,temp7
                movff   MAX_7,temp6

page_18         movlw   d'18'           ; Page N
                cpfseq  pages
                goto    page_19         ; Sinon suite
                movff   OFFSET_8,temp7
                movff   MAX_8,temp6
page_19
;-------------- Affichage champ 1 (Max) ------------------------------

                movlw   d'69'               ; X1
                movwf   param_1
                movlw   d'11'               ; Y1
                movwf   param_2
                movlw   d'91'               ; X2
                movwf   param_3
                movlw   d'18'               ; Y2
                movwf   param_4
                movlw   d'02'               ; CLEAR AREA
                movwf   param_5
                call    Commande_AREA
             
                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x41            ; 'A' Font 5x7
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x32            ; '2' Espacing 2 pixels
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'70'           ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'18'            ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                ;---------------------------------------------------------------
                movff   temp6,param_1   ; Variable temporaire de OFFSET
                ;---------------------------------------------------------------
                call    vol255_db_BCD

                movff   param_1,temp5    ; Sauvegarde valeur dizaine

                movff   param_4,param_1	; Transfert valeur signe vers parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movf    temp5,0         ; valeur des dizaines
                addlw   0x30            ; adition avec caractere '0'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movf    param_2,0		; valeur des unites
                addlw   0x30            ; addition avec caractere '0'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0x2E            ; 'Point'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movf    param_3,0		; valeur des unitees
                addlw   0x30            ; addition avec caractere '0'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle


;-------------- Affichage champ 2 (OFFSET) -------------------------------------
                movlw   d'69'               ; X1
                movwf   param_1
                movlw   d'25'               ; Y1
                movwf   param_2
                movlw   d'91'               ; X2
                movwf   param_3
                movlw   d'31'               ; Y2
                movwf   param_4
                movlw   d'02'               ; CLEAR AREA
                movwf   param_5
                call    Commande_AREA

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x41            ; 'A' Font 5x7
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x32            ; '2' Espacing 2 pixels
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'70'           ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'31'            ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                ;---------------------------------------------------------------
                movff   temp7,param_1   ; Variable temporaire de OFFSET
                ;---------------------------------------------------------------
                call    vol255_db_BCD

                movff   param_1,temp5    ; Sauvegarde valeur dizaine

                movff   param_4,param_1	; Transfert valeur signe vers parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movf    temp5,0         ; valeur des dizaines
                addlw   0x30            ; adition avec caractere '0'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movf    param_2,0		; valeur des unites
                addlw   0x30            ; addition avec caractere '0'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0x2E            ; 'Point'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movf    param_3,0		; valeur des unitees
                addlw   0x30            ; addition avec caractere '0'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

;****************** CADRES DE NAVIGATION ***************************************

        ;------ CHAMP 0 --------------------------------------------------
                movlw   0x00            ; W = 0
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_0     ; Sinon suite

                movlw   d'105'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'110'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_0
        ;------ CHAMP 1 --------------------------------------------------
                movlw   0x01            ; W = 1
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_1     ; Sinon suite

                movlw   d'111'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'132'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_1
        ;------ CHAMP 2 --------------------------------------------------
                movlw   0x02            ; W = 2
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_2     ; Sinon suite

                movlw   d'133'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'139'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_2
        ;------ CHAMP 3 --------------------------------------------------
                movlw   0x03            ; W = 0
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_3     ; Sinon suite

                movlw   d'69'           ; X1
                movwf   param_1
                movlw   d'12'           ; Y1
                movwf   param_2
                movlw   d'91'           ; X2
                movwf   param_3
                movlw   d'18'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT AREA
                movwf   param_5
                call    Commande_AREA
champ_Fin_3
        ;------ CHAMP 4 --------------------------------------------------
                movlw   0x04            ; W = 0
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_4     ; Sinon suite

                movlw   d'69'           ; X1
                movwf   param_1
                movlw   d'25'           ; Y1
                movwf   param_2
                movlw   d'91'           ; X2
                movwf   param_3
                movlw   d'31'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT AREA
                movwf   param_5
                call    Commande_AREA
champ_Fin_4
;------------------ exit -------------------------------------------------------

exit                return                      ; retour du sous programme
                    END

