;*******************************************************************************
;  Filename:    page_SYSTEM.asm                                                   *
;                                                                              *
;  Version:  	22/02/2013    V1.0      Version originale                      *
;                                                                              *
;  Author:        Philippe DOUILLARD                                           *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                                                              *
;  Affichage des pages SYSTEM                                                    *
;                                                                              *
;*******************************************************************************

;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
        #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************

	extern Main,par_rw0_rs0,par_rw0_rs1,vol255_db_BCD,Delay_short
    extern Commande_CLS,Commande_TEXT,Commande_AREA,Commande_DB,dec8_bcd3

;********************** VARIABLES EXTERNES *************************************

    extern      MASTER_Val,MASTER_Max,MASTER_Min
    extern      param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8
    extern      param_9
    extern      memo1,memo3,temp1,temp2,temp3,temp5,temp6,temp7
    extern      pages,champ

    extern      CONTRAST_ECO,CONTRAST_MAX,CONTRAST_TEMPO,LED_ECO,LED_MAX
    extern      TON_REL_1,TOF_REL_1,TON_REL_2,TOF_REL_2,TON_REL_3,TOF_REL_3
    extern      TOF_VFD_OFF,POTAR_Max,VOLUME_CONF,MASTER_Min,MASTER_Max

;************************* SOUS ROUTINE ****************************************

PROG            CODE

page_SYSTEM
        global page_SYSTEM

;-------------- Test si rafraichissement ------------------------------------------------
                btfsc   memo3,0         ; Test si changement memu CLS si vrai
                goto    init

                btfss   memo3,1         ; Si FLAG (Rafraichissement)
                goto    exit            ; Simon exit
                goto    affichage


init            call    Commande_CLS
                bcf     memo3,0

;************** AFFICHAGE FOND ECRAN *******************************************

;-------------- Affichage TITRE ------------------------------------------------
        
                movlw   d'00'           ; X
                movwf   param_1
                movlw   d'05'           ; Y
                movwf   param_2
                movlw   d'00'           ; N Chaine
                movwf   param_3
                movlw   d'08'           ; Nb Caracteres+1
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movff   pages,temp1     ; Sauve N Page
                movlw   d'30'           ;
                subwf   temp1,1         ; N Page - 30
                movlw   d'48'           ; Chiffre 0
                addwf   temp1           ; N Page + caractere 0
                movff   temp1,param_1   ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0x2F            ; Caractere '/'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0x38            ; Caractere '8'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

;-------------- Affichage vignettes ------------------ PAGE 31 -----------------
                movlw   d'31'           ; pages N
                cpfseq  pages
                goto    pages_31_FIN    ; Sinon suite

                movlw   d'00'           ; X
                movwf   param_1
                movlw   d'18'           ; Y
                movwf   param_2
                movlw   d'30'           ; N Chaine
                movwf   param_3
                movlw   d'12'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'105'          ; X
                movwf   param_1
                movlw   d'18'           ; Y
                movwf   param_2
                movlw   d'46'           ; N Chaine
                movwf   param_3
                movlw   d'03'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'00'           ; X
                movwf   param_1
                movlw   d'31'           ; Y
                movwf   param_2
                movlw   d'31'           ; N Chaine
                movwf   param_3
                movlw   d'12'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'105'          ; X
                movwf   param_1
                movlw   d'31'           ; Y
                movwf   param_2
                movlw   d'46'           ; N Chaine
                movwf   param_3
                movlw   d'03'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT
pages_31_FIN

;-------------- Affichage vignettes ------------------ PAGE 32 -----------------
                movlw   d'32'           ; pages N
                cpfseq  pages
                goto    pages_32_FIN    ; Sinon suite

                movlw   d'00'           ; X
                movwf   param_1
                movlw   d'18'           ; Y
                movwf   param_2
                movlw   d'32'           ; N Chaine
                movwf   param_3
                movlw   d'12'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'105'          ; X
                movwf   param_1
                movlw   d'18'           ; Y
                movwf   param_2
                movlw   d'46'           ; N Chaine
                movwf   param_3
                movlw   d'03'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'00'           ; X
                movwf   param_1
                movlw   d'31'           ; Y
                movwf   param_2
                movlw   d'33'           ; N Chaine
                movwf   param_3
                movlw   d'12'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'105'          ; X
                movwf   param_1
                movlw   d'31'           ; Y
                movwf   param_2
                movlw   d'46'           ; N Chaine
                movwf   param_3
                movlw   d'03'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT
pages_32_FIN
;-------------- Affichage vignettes ------------------ PAGE 33 -----------------
                movlw   d'33'           ; pages N
                cpfseq  pages
                goto    pages_33_FIN    ; Sinon suite

                movlw   d'00'           ; X
                movwf   param_1
                movlw   d'18'           ; Y
                movwf   param_2
                movlw   d'34'           ; N Chaine
                movwf   param_3
                movlw   d'12'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'105'          ; X
                movwf   param_1
                movlw   d'18'           ; Y
                movwf   param_2
                movlw   d'46'           ; N Chaine
                movwf   param_3
                movlw   d'03'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'00'           ; X
                movwf   param_1
                movlw   d'31'           ; Y
                movwf   param_2
                movlw   d'35'           ; N Chaine
                movwf   param_3
                movlw   d'12'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'105'          ; X
                movwf   param_1
                movlw   d'31'           ; Y
                movwf   param_2
                movlw   d'46'           ; N Chaine
                movwf   param_3
                movlw   d'03'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT
pages_33_FIN
;-------------- Affichage vignettes ------------------ PAGE 34 -----------------
                movlw   d'34'           ; pages N
                cpfseq  pages
                goto    pages_34_FIN    ; Sinon suite

                movlw   d'00'           ; X
                movwf   param_1
                movlw   d'18'           ; Y
                movwf   param_2
                movlw   d'36'           ; N Chaine
                movwf   param_3
                movlw   d'12'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'105'          ; X
                movwf   param_1
                movlw   d'18'           ; Y
                movwf   param_2
                movlw   d'46'           ; N Chaine
                movwf   param_3
                movlw   d'03'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'00'           ; X
                movwf   param_1
                movlw   d'31'           ; Y
                movwf   param_2
                movlw   d'37'           ; N Chaine
                movwf   param_3
                movlw   d'12'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'105'          ; X
                movwf   param_1
                movlw   d'31'           ; Y
                movwf   param_2
                movlw   d'46'           ; N Chaine
                movwf   param_3
                movlw   d'03'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT
pages_34_FIN
;-------------- Affichage vignettes ------------------ PAGE 35 -----------------
                movlw   d'35'           ; pages N
                cpfseq  pages
                goto    pages_35_FIN    ; Sinon suite

                movlw   d'00'           ; X
                movwf   param_1
                movlw   d'18'           ; Y
                movwf   param_2
                movlw   d'38'           ; N Chaine
                movwf   param_3
                movlw   d'12'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT



                movlw   d'00'           ; X
                movwf   param_1
                movlw   d'31'           ; Y
                movwf   param_2
                movlw   d'39'           ; N Chaine
                movwf   param_3
                movlw   d'12'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT


pages_35_FIN
;-------------- Affichage vignettes ------------------ PAGE 36 -----------------
                movlw   d'36'           ; pages N
                cpfseq  pages
                goto    pages_36_FIN    ; Sinon suite

                movlw   d'00'           ; X
                movwf   param_1
                movlw   d'18'           ; Y
                movwf   param_2
                movlw   d'40'           ; N Chaine
                movwf   param_3
                movlw   d'12'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'105'          ; X
                movwf   param_1
                movlw   d'18'           ; Y
                movwf   param_2
                movlw   d'47'           ; N Chaine
                movwf   param_3
                movlw   d'03'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'00'           ; X
                movwf   param_1
                movlw   d'31'           ; Y
                movwf   param_2
                movlw   d'41'           ; N Chaine
                movwf   param_3
                movlw   d'12'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'105'          ; X
                movwf   param_1
                movlw   d'31'           ; Y
                movwf   param_2
                movlw   d'47'           ; N Chaine
                movwf   param_3
                movlw   d'03'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT
pages_36_FIN
;-------------- Affichage vignettes ------------------ PAGE 37 -----------------
                movlw   d'37'           ; pages N
                cpfseq  pages
                goto    pages_37_FIN    ; Sinon suite

                movlw   d'00'           ; X
                movwf   param_1
                movlw   d'18'           ; Y
                movwf   param_2
                movlw   d'42'           ; N Chaine
                movwf   param_3
                movlw   d'12'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'00'           ; X
                movwf   param_1
                movlw   d'31'           ; Y
                movwf   param_2
                movlw   d'43'           ; N Chaine
                movwf   param_3
                movlw   d'12'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

pages_37_FIN
;-------------- Affichage vignettes ------------------ PAGE 38 -----------------
                movlw   d'38'           ; pages N
                cpfseq  pages
                goto    pages_38_FIN    ; Sinon suite

                movlw   d'00'           ; X
                movwf   param_1
                movlw   d'18'           ; Y
                movwf   param_2
                movlw   d'44'           ; N Chaine
                movwf   param_3
                movlw   d'12'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'105'          ; X
                movwf   param_1
                movlw   d'18'           ; Y
                movwf   param_2
                movlw   d'20'           ; N Chaine
                movwf   param_3
                movlw   d'03'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'00'           ; X
                movwf   param_1
                movlw   d'31'           ; Y
                movwf   param_2
                movlw   d'45'           ; N Chaine
                movwf   param_3
                movlw   d'12'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

                movlw   d'105'          ; X
                movwf   param_1
                movlw   d'31'           ; Y
                movwf   param_2
                movlw   d'20'           ; N Chaine
                movwf   param_3
                movlw   d'03'           ; Nb Caracteres
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT
pages_38_FIN
 
;-------------- LIGNE ----------------------------------------------------------

                movlw   0xF1                ; SET AREA
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs0         ; routine comunication paralelle

                movlw   d'00'               ; X1
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   d'06'               ; Y1
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   d'139'               ; X2
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   d'06'               ; Y2
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1         ; routine comunication paralelle

                movlw   0x46                ; CMD (Invert Area)
                movwf   param_1             ; Transfert parametre
                call    par_rw0_rs1

                call    Delay_short
;************** Actualisation des variables ************************************

affichage       bcf     memo3,1         ; Reset FLAG
                
;-------------- Effacement zone navigation -------------------------------------
                movlw   d'70'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'139'          ; X2
                movwf   param_3
                movlw   d'05'           ; Y2
                movwf   param_4
                movlw   d'02'           ; CLEAR
                movwf   param_5
                call    Commande_AREA

;-------------- Affichage Barre de NAVIGATION ----------------------------------

                movlw   d'106'          ; X
                movwf   param_1
                movlw   d'05'           ; Y
                movwf   param_2
                movlw   d'11'           ; N Chaine
                movwf   param_3
                movlw   d'08'           ; Nb Caracteres+1
                movwf   param_4
                movlw   d'01'           ; Fonte
                movwf   param_5
                call    Commande_TEXT

;-------------- Affichage volume (-96.0/+31.5 dB) ------------------------------

                movlw   d'70'               ; X
                movwf   param_6
                movlw   d'05'               ; Y
                movwf   param_7
                movlw   d'01'               ; FONTE
                movwf   param_8
                movff   MASTER_Val,param_9  ; Variable  Afficher
                call    Commande_DB

;-------------- Selection des variables ----------------------------------------
page_31         movlw   d'31'                   ; Page N
                cpfseq  pages
                goto    page_32                 ; Sinon suite
                movff   TON_REL_1,temp6
                movff   TOF_REL_1,temp7

page_32         movlw   d'32'                   ; Page N
                cpfseq  pages
                goto    page_33                 ; Sinon suite
                movff   TON_REL_2,temp6
                movff   TOF_REL_2,temp7

page_33         movlw   d'33'                   ; Page N
                cpfseq  pages
                goto    page_34                 ; Sinon suite
                movff   TON_REL_3,temp6
                movff   TOF_REL_3,temp7

page_34         movlw   d'34'                   ; Page N
                cpfseq  pages
                goto    page_35                 ; Sinon suite
                movff   CONTRAST_TEMPO,temp6
                movff   TOF_VFD_OFF,temp7

page_35         movlw   d'35'                   ; Page N
                cpfseq  pages
                goto    page_36                 ; Sinon suite
                movff   CONTRAST_ECO,temp6
                movff   CONTRAST_MAX,temp7

page_36         movlw   d'36'                   ; Page N
                cpfseq  pages
                goto    page_37                 ; Sinon suite
                movff   LED_ECO,temp6
                movff   LED_MAX,temp7

page_37         movlw   d'37'                   ; Page N
                cpfseq  pages
                goto    page_38                 ; Sinon suite
                movff   POTAR_Max,temp6
                movff   VOLUME_CONF,temp7

page_38         movlw   d'38'                   ; Page N
                cpfseq  pages
                goto    page_39                 ; Sinon suite
                movff   MASTER_Min,temp6
                movff   MASTER_Max,temp7

page_39
;-------------- Affichage champ 1 ----------------------------------------------
                movlw   d'69'               ; X1
                movwf   param_1
                movlw   d'11'               ; Y1
                movwf   param_2
                movlw   d'91'               ; X2
                movwf   param_3
                movlw   d'18'               ; Y2
                movwf   param_4
                movlw   d'02'               ; CLEAR AREA
                movwf   param_5
                call    Commande_AREA
                
                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x41            ; 'A' Font 5x7
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x32            ; '2' Espacing 2 pixels
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'70'           ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'18'           ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'38'           ; Page N
                cpfseq  pages
                goto    page_31a37ch1    ; Sinon suite

                ;---------------------------------------------------------------
                movff   temp6,param_1   ; Variable temporaire de OFFSET
                ;---------------------------------------------------------------
                call    vol255_db_BCD

                movff   param_1,temp5    ; Sauvegarde valeur dizaine

                movff   param_4,param_1	; Transfert valeur signe vers parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movf    temp5,0         ; valeur des dizaines
                addlw   0x30            ; adition avec caractere '0'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movf    param_2,0		; valeur des unites
                addlw   0x30            ; addition avec caractere '0'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0x2E            ; 'Point'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movf    param_3,0		; valeur des unitees
                addlw   0x30            ; addition avec caractere '0'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    page_31a37fin1

page_31a37ch1   ;---------------------------------------------------------------
                movff   temp6,param_1   ; Variable temporaire de OFFSET
                ;---------------------------------------------------------------
                call     dec8_bcd3

                movf    param_1,0	; valeur des centaines
                addlw   0x30		; adition avec caractere '0'
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movf    param_2,0		; valeur des dizaines
                addlw   0x30		; adition avec caractere '0'
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movf    param_3,0		; valeur des unitees
                addlw   0x30		; adition avec caract?re '0'
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle
page_31a37fin1
;-------------- Affichage champ 2 ----------------------------------------------
                movlw   d'69'               ; X1
                movwf   param_1
                movlw   d'25'               ; Y1
                movwf   param_2
                movlw   d'91'               ; X2
                movwf   param_3
                movlw   d'31'               ; Y2
                movwf   param_4
                movlw   d'02'               ; CLEAR AREA
                movwf   param_5
                call    Commande_AREA

                
                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x41            ; 'A' Font 5x7
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF2            ; SET FONT
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   0x32            ; '2' Espacing 2 pixels
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0xF0            ; SET GRAFIC POSITION
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs0     ; routine comunication paralelle

                movlw   d'70'           ; X
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'31'            ; Y
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   d'38'           ; Page N
                cpfseq  pages
                goto    page_31a37ch2    ; Sinon suite

                ;---------------------------------------------------------------
                movff   temp7,param_1   ; Variable temporaire de OFFSET
                ;---------------------------------------------------------------
                call    vol255_db_BCD

                movff   param_1,temp5    ; Sauvegarde valeur dizaine

                movff   param_4,param_1	; Transfert valeur signe vers parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movf    temp5,0         ; valeur des dizaines
                addlw   0x30            ; adition avec caractere '0'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movf    param_2,0		; valeur des unites
                addlw   0x30            ; addition avec caractere '0'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movlw   0x2E            ; 'Point'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle

                movf    param_3,0		; valeur des unitees
                addlw   0x30            ; addition avec caractere '0'
                movwf   param_1         ; Transfert parametre
                call    par_rw0_rs1     ; routine comunication paralelle
                goto    page_31a37fin2
page_31a37ch2   ;---------------------------------------------------------------
                movff   temp7,param_1   ; Variable temporaire de OFFSET
                ;---------------------------------------------------------------
                call     dec8_bcd3

                movf    param_1,0	; valeur des centaines
                addlw   0x30		; adition avec caractere '0'
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movf    param_2,0		; valeur des dizaines
                addlw   0x30		; adition avec caractere '0'
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle

                movf    param_3,0		; valeur des unitees
                addlw   0x30		; adition avec caract?re '0'
                movwf   param_1		; Transfert parametre
                call    par_rw0_rs1	; routine comunication paralelle
page_31a37fin2
;****************** CADRES DE NAVIGATION ***************************************


        ;------ CHAMP 0 --------------------------------------------------
                movlw   0x00            ; W = 0
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_0     ; Sinon suite

                movlw   d'105'          ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'110'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_0
        ;------ CHAMP 1 --------------------------------------------------
                movlw   0x01            ; W = 1
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_1     ; Sinon suite

                movlw   d'111'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'132'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_1
        ;------ CHAMP 2 --------------------------------------------------
                movlw   0x02            ; W = 2
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_2     ; Sinon suite

                movlw   d'133'           ; X1
                movwf   param_1
                movlw   d'00'           ; Y1
                movwf   param_2
                movlw   d'139'          ; X2
                movwf   param_3
                movlw   d'04'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT
                movwf   param_5
                call    Commande_AREA
champ_Fin_2
        ;------ CHAMP 3 --------------------------------------------------
                movlw   0x03            ; W = 0
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_3     ; Sinon suite

                movlw   d'69'           ; X1
                movwf   param_1
                movlw   d'12'           ; Y1
                movwf   param_2
                movlw   d'91'           ; X2
                movwf   param_3
                movlw   d'18'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT AREA
                movwf   param_5
                call    Commande_AREA
champ_Fin_3
        ;------ CHAMP 4 --------------------------------------------------
                movlw   0x04            ; W = 0
                cpfseq  champ           ; Compare si champ = 0 (W)
                goto    champ_Fin_4     ; Sinon suite

                movlw   d'69'           ; X1
                movwf   param_1
                movlw   d'25'           ; Y1
                movwf   param_2
                movlw   d'91'           ; X2
                movwf   param_3
                movlw   d'31'           ; Y2
                movwf   param_4
                movlw   d'00'           ; INVERT AREA
                movwf   param_5
                call    Commande_AREA
champ_Fin_4
;------------------ exit -------------------------------------------------------

exit                return                      ; retour du sous programme
                    END

