;*******************************************************************************
;  Filename:  par_rw0_rs0.asm                                                  *
;                                                                              *
;  Version:  	08/11/2006    V1.0      Version originale pour 16F577          *
;  Version:  	08/11/2006    V2.0      Adaptation 18F4520                     *
;                                                                              *
;  Author:        Philippe DOUILLARD                                           *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                                                              *
;  Envoie 1 octet sur port paralelle avec RW=0 RS=0                            *
;  Parametre 1 = Octet a envoyer                                               *
;                                                                              *
;*******************************************************************************

;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
        #include <P18F4520.INC>     ;processor specific variable definitions

;************************ MODULES EXTERNES *************************************
	extern param_1
	extern Delay_short

;************************* SOUS ROUTINE ****************************************

PROG CODE

par_rw0_rs0
                global par_rw0_rs0

;-------------- PAGE SELECT ----------------------------------------------------

                BCF STATUS,5		; Select BANK 0
                BCF STATUS,6		; par defaut

;-------------- Sous routine ---------------------------------------------------

par_rw0_rs0_1   btfss PORTA,0		; Test si busy
                goto par_rw0_rs0_1	; si busy alors attend

                bcf PORTE,0         ; RW = 0
                bcf PORTE,1         ; RS = 0

                movff param_1,PORTD	; Octet
                
                bsf PORTE,2         ; Enable = 1
                bcf PORTE,2         ; Enable = 0

                call Delay_short
;-------------- exit -----------------------------------------------------------

                return              ; retour du sous programme
			
                END
