;*******************************************************************************
;  Filename:    volume.asm                                                     *
;                                                                              *
;  Version:  	08/11/2006    V1.0      Version originale pour 16F577          *
;  Version:  	08/11/2006    V2.0      Adaptation 18F4520                     *
;                                                                              *
;  Author:        Philippe DOUILLARD                                           *
;*******************************************************************************
;  DESCRIPTION                                                                 *
;                                                                              *
;  Incremente et dcremente le volume de 0 a 255 avec encodeur                 *
;                                                                              *
;*******************************************************************************

;*********************** Directive d' assemblage pour MPLAB   ******************

	LIST P=18F4520, F=INHX32    ;directive to define processor & file format
        #include <P18F4520.INC>     ;processor specific variable definitions

;**************** MODULES et VARIABLES EXTERNES ********************************
	extern  param_1
	extern  memo1,memo3,MASTER_Val,MASTER_Min, MASTER_Max,POTAR_Max,POTAR_Val
	extern  POTAR_Min

	extern  Main

;************************* SOUS ROUTINE ****************************************

PROG            CODE

volume_255
                global volume_255

;-------------- Front montant CH A ---------------------------------------------
                bcf     memo1,1         ; RESET bit front
                btfss   PORTA,2         ; Si CHA = 1 JUMP
                goto    FM_exit         ; Sinon GOTO EXIT
                btfsc   memo1,0         ; Si etat anterieur = 0 JUMP
                goto    FM_exit         ; Sinon GOTO EXIT
                bsf     memo1,1         ; SET bit front
                bsf     memo3,1         ; SET bit refresh
FM_exit

;-------------- Memo etat anterieur CH A ---------------------------------------
                btfss   PORTA,2         ; Entree CHA = 1 JUMP
                bcf     memo1,0         ; RESET bit (Memo �tat ant�rieur)
                btfsc   PORTA,2         ; Entree CHA = 0 JUMP
                bsf     memo1,0         ; SET bit (Memo1,1 etat anterieur)

;-------------- Test si Incrementation -----------------------------------------
                btfss   memo1,1         ; Si FM CHA = 1 -> saut ligne
                goto    inc_exit        ; SINON GOTO exit
                btfsc   PORTA,3         ; Si entree CHB = 1 JUMP
                goto    inc_exit        ; SINON GOTO exit
                goto    incremente_pot  ; SIOUI incrementation POTAR
inc_exit

;-------------- Test si Decrementation -----------------------------------------
                btfss   memo1,1         ; Entree CHA = 1 JUMP
                goto    Exit            ; SINON GOTO exit
                btfss   PORTA,3         ; Si entree CHB = 0 JUMP
                goto    Exit            ; SINON GOTO exit
                goto    decremente_pot  ; SIOUI decremente

;-------------- Incrementation -------------------------- POTAR ----------------

incremente_pot  movf    POTAR_Max,0
                cpfseq  POTAR_Val
                goto    inc_pot
                clrf    POTAR_Val
                goto    incremente

inc_pot         incf    POTAR_Val
                goto    Exit
;-------------- Incrementation -------------------------- MASTER ---------------

incremente      movf    MASTER_Max,0	; W = MASTER_Vol - MASTER_Max
                cpfseq  MASTER_Val		; Si ZERO=1 -> saut ligne
                incf    MASTER_Val,1	; SINON incremente
                goto    Exit

;-------------- Decrementation -------------------------- POTAR ----------------

decremente_pot  movf    POTAR_Min,0
                cpfseq  POTAR_Val
                goto    dec_pot
                movff   POTAR_Max,POTAR_Val
                goto    decremente

dec_pot         decf    POTAR_Val
                goto    Exit
;-------------- Decrementation -------------------------- MASTER ---------------

decremente      movf    MASTER_Min,0	; W = MASTER_Vol - MASTER_Max
                cpfseq  MASTER_Val		; Si ZERO=1 -> saut ligne
                decf    MASTER_Val,1	; SINON incremente
                goto    Exit
Exit

                return                  ; retour du sous programme
			    END
